
#include "stdafx.h" 
#include "emule.h"
#include "CommentDialogLst.h"
#include "PastComment.h"		// #zegzav:pastcomment

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


#define DRAWTEXTFMT		(DT_LEFT | DT_BOTTOM | DT_SINGLELINE | DT_END_ELLIPSIS | DT_NOPREFIX)	// #zegzav:pastcomment


IMPLEMENT_DYNAMIC(CCommentDialogLst, CDialog) 
CCommentDialogLst::CCommentDialogLst(CPartFile* file) 
   : CResizableDialog(CCommentDialogLst::IDD, 0) 
{ 
   m_file = file; 
} 

CCommentDialogLst::~CCommentDialogLst() 
{ 
} 

void CCommentDialogLst::DoDataExchange(CDataExchange* pDX) 
{ 
   CDialog::DoDataExchange(pDX); 
   DDX_Control(pDX, IDC_LST, pmyListCtrl);
} 

BEGIN_MESSAGE_MAP(CCommentDialogLst, CResizableDialog) 
   ON_BN_CLICKED(IDCOK, OnBnClickedApply) 
   ON_BN_CLICKED(IDCREF, OnBnClickedRefresh) 
   ON_WM_DESTROY()	// eklmn: bugfix(00): resource cleanup due to CResizableDialog
   ON_WM_DRAWITEM()	// #zegzav:pastcomment
END_MESSAGE_MAP() 



void CCommentDialogLst::OnBnClickedApply() 
{ 
   CDialog::OnOK(); 
} 

void CCommentDialogLst::OnBnClickedRefresh() 
{ 
   CompleteList(); 
} 

BOOL CCommentDialogLst::OnInitDialog(){ 
   CResizableDialog::OnInitDialog(); 

   //SetIcon(theApp.emuledlg->sourceTrayIcon,FALSE);

   AddAnchor(IDC_LST,TOP_LEFT,BOTTOM_RIGHT);
   AddAnchor(IDCOK,BOTTOM_RIGHT);
   AddAnchor(IDCREF,BOTTOM_RIGHT);
   AddAnchor(IDC_CMSTATUS,BOTTOM_LEFT);

   pmyListCtrl.InsertColumn(0, GetResString(IDS_CD_UNAME), LVCFMT_LEFT, 100, -1); 
   pmyListCtrl.InsertColumn(1, GetResString(IDS_DL_FILENAME), LVCFMT_LEFT, 150, -1); 
   pmyListCtrl.InsertColumn(2, GetResString(IDS_QL_RATING), LVCFMT_LEFT, 80, 1); 
   pmyListCtrl.InsertColumn(3, GetResString(IDS_COMMENT), LVCFMT_LEFT, 315, 1);		//netwolf 07.05.03 (was 250)

   Localize(); 
   CompleteList(); 

   return TRUE; 
} 

void CCommentDialogLst::Localize(void){ 
   GetDlgItem(IDCOK)->SetWindowText(GetResString(IDS_CW_CLOSE)); 
   GetDlgItem(IDCREF)->SetWindowText(GetResString(IDS_CMT_REFRESH)); 
   SetWindowText(GetResString(IDS_CMT_READALL)+_T(" (")+ m_file->GetFileName() +_T(")")); 
} 

void CCommentDialogLst::CompleteList ()
{ 
	POSITION pos1,pos2; 
	CUpDownClient* cur_src; 
	int count=0; 
	
	pmyListCtrl.DeleteAllItems();
	
	for (int sl=0;sl<SOURCESSLOTS;sl++) if (!m_file->srclists[sl].IsEmpty())
	for (pos1 = m_file->srclists[sl].GetHeadPosition(); (pos2 = pos1) != NULL;) 
	{ 
		m_file->srclists[sl].GetNext(pos1); 
		cur_src = m_file->srclists[sl].GetAt(pos2); 
		
		if (cur_src->GetFileComment().GetLength()>0 || cur_src->GetFileRate()>0)
		{
			pmyListCtrl.InsertItem(count, cur_src->GetUserName()); 
			pmyListCtrl.SetItemText(count, 1, cur_src->GetClientFilename()); 
			pmyListCtrl.SetItemText(count, 2, GetRateString(cur_src->GetFileRate())); 
			pmyListCtrl.SetItemText(count, 3, cur_src->GetFileComment()); 
			count++;
	  	} 
	} 

	// [Lord KiRon/DonGato]
	// Adds support to show comments entered by the user himself
	CString comment;
	CString rated; 
   	comment = m_file->GetFileComment(); 
	rated = GetRateString(m_file->GetFileRate());
	if ((comment != "")||(rated!=GetRateString(0)))
	{ 
		pmyListCtrl.InsertItem(count, theApp.glob_prefs->GetUserNick()); 
		pmyListCtrl.SetItemText(count, 1, m_file->GetFileName()); 
		pmyListCtrl.SetItemText(count, 2, rated); 
		pmyListCtrl.SetItemText(count, 3, comment); 
		count++;
	}
	// [/Lord KiRon]
	
	// #zegzav:pastcomment (BEGIN)
	CPastCommentList &pclist= m_file->GetPastCommentList();
	for (pos1= pclist.GetHeadPosition(); pos1 != 0;)
	{
		CPastComment &pc= pclist.GetNext(pos1);
		pmyListCtrl.InsertItem(LVIF_TEXT | LVIF_PARAM, count, pc.GetClientName(), 0, 0, 0, 1); 
		pmyListCtrl.SetItemText(count, 1, pc.GetFileName()); 
		pmyListCtrl.SetItemText(count, 2, GetRateString(pc.GetRate())); 
		pmyListCtrl.SetItemText(count, 3, pc.GetComment()); 
		count++;
	}
	// #zegzav:pastcomment (END)
	
	CString info=_T("");
	if (count==0) info=_T("(")+GetResString(IDS_CMT_NONE)+_T(")");
	GetDlgItem(IDC_CMSTATUS)->SetWindowText(info);
	m_file->UpdateFileRatingCommentAvail();
}
// v- eklmn: bugfix(00): resource cleanup due to CResizableDialog
void CCommentDialogLst::OnDestroy()
{
	CResizableDialog::OnDestroy();
}
// ^- eklmn: bugfix(00): resource cleanup due to CResizableDialog

// #zegzav:pastcomment (BEGIN)
void CCommentDialogLst::OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct)	
{
	if (nIDCtl != IDC_LST)
		return;

	UINT nItemID= lpDrawItemStruct->itemID;
	if (nItemID == (UINT)-1)
		return;

	CString strUserName= pmyListCtrl.GetItemText(nItemID, 0);
	CString strFileName= pmyListCtrl.GetItemText(nItemID, 1);
	CString strRate= pmyListCtrl.GetItemText(nItemID, 2);
	CString strComment= pmyListCtrl.GetItemText(nItemID, 3);
	bool bPastComment= (pmyListCtrl.GetItemData(nItemID) != 0);

	CDC dc;
	dc.Attach(lpDrawItemStruct->hDC);
	CRect rc(lpDrawItemStruct->rcItem);

	dc.FillSolidRect(rc, ::GetSysColor(COLOR_WINDOW));
	dc.SetTextColor(bPastComment ? ::GetSysColor(COLOR_GRAYTEXT) : ::GetSysColor(COLOR_WINDOWTEXT));
	dc.SetBkMode(TRANSPARENT);

	rc.right= rc.left + pmyListCtrl.GetColumnWidth(0) - 2;
	rc.left+= 2;
	dc.DrawText(strUserName, rc, DRAWTEXTFMT);

	rc.left= rc.right + 4;
	rc.right+= pmyListCtrl.GetColumnWidth(1);
	dc.DrawText(strFileName, rc, DRAWTEXTFMT);

	rc.left= rc.right + 4;
	rc.right+= pmyListCtrl.GetColumnWidth(2);
	dc.DrawText(strRate, rc, DRAWTEXTFMT);

	rc.left= rc.right + 4;
	rc.right+= pmyListCtrl.GetColumnWidth(3);
	dc.DrawText(strComment, rc, DRAWTEXTFMT);

	dc.Detach();
}
// #zegzav:pastcomment (END)

