// FileDetails.cpp : implementation file
//

#include "stdafx.h"
#include "..\otherfunctions.h"
#include "..\UpDownClient.h"
#include "..\TitleMenu.h"
#include "..\emule.h"
#include "..\resource.h"
#include "..\CommentDialogLst.h"
#include "FileDetails.h"
#include "file_ver.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFileDetails

IMPLEMENT_DYNAMIC(CFileDetails, CPropertySheet)

CFileDetails::CFileDetails(UINT nIDCaption, CPartFile* pFile, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(nIDCaption, pParentWnd, iSelectPage)
{
	Init(pFile);
}

CFileDetails::CFileDetails(LPCTSTR pszCaption, CPartFile* pFile, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(pszCaption, pParentWnd, iSelectPage)
{
	Init(pFile);
}

CFileDetails::~CFileDetails()
{
}

void CFileDetails::Init(CPartFile* pFile)
{	
	m_pFile = pFile;
	m_nTimer = 0;
	
	m_wndGeneral.m_pFile = m_pFile;
	m_wndTransfer.m_pFile = m_pFile;
	m_wndSourceNames.m_pFile = m_pFile;
	m_wndAviInfo.m_pFile = m_pFile;
	m_wndParts.m_pFile = m_pFile;

	AddPage(&m_wndGeneral);
	AddPage(&m_wndTransfer);
	AddPage(&m_wndSourceNames);
	
	if(m_pFile)
	{
		if(m_pFile->IsMovie())
		{
			AddPage(&m_wndAviInfo);
		}
	}

	AddPage(&m_wndParts);
}

BEGIN_MESSAGE_MAP(CFileDetails, CPropertySheet)
	//{{AFX_MSG_MAP(CFileDetails)
	//}}AFX_MSG_MAP
	ON_WM_TIMER()
	ON_WM_DESTROY()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFileDetails message handlers

BOOL CFileDetails::OnInitDialog()
{
	CPropertySheet::OnInitDialog();
	Localize();
	m_nTimer = SetTimer(301, 5000, 0);
	UpdateData();
	return true;
}

void CFileDetails::OnTimer(UINT nIDEvent)
{
	if(nIDEvent == m_nTimer)
	{
	//	UpdateData();
	}

	CPropertySheet::OnTimer(nIDEvent);
}

void CFileDetails::UpdateData()
{
	m_wndGeneral.UpdateData();
	m_wndTransfer.UpdateData();
	m_wndSourceNames.UpdateData();

	if(m_pFile)
	{
		if(m_pFile->IsMovie())
		{
			m_wndAviInfo.UpdateData();
		}
	}
		
	//	m_wndParts.UpdateData();
}

void CFileDetails::Localize()
{

}

void CFileDetails::OnDestroy()
{
	if(m_nTimer != 0)
	{
		KillTimer(m_nTimer);
	}

	CPropertySheet::OnDestroy();
}

/////////////////////////////////////////////////////////////////////////////
// CFDGeneral property page

IMPLEMENT_DYNCREATE(CFDGeneral, CPropertyPage)

CFDGeneral::CFDGeneral() : CPropertyPage(CFDGeneral::IDD)
{
	//{{AFX_DATA_INIT(CFDGeneral)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_pFile = NULL;
	m_hFileIcon = NULL;
}

CFDGeneral::~CFDGeneral()
{
	if(m_hFileIcon != NULL)
	{
		::DestroyIcon(m_hFileIcon);
	}
}

void CFDGeneral::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFDGeneral)
	DDX_Control(pDX, IDC_PARTFILESTATUS_VAL, m_ctrlPartfileStatus);
	DDX_Control(pDX, IDC_METFILE_VAL, m_ctrlMetFile);
	DDX_Control(pDX, IDC_HASH_VAL, m_ctrlHash);
	DDX_Control(pDX, IDC_FOLDER_VAL, m_ctrlFolder);
	DDX_Control(pDX, IDC_FILETYPE_VAL, m_ctrlFiletype);
	DDX_Control(pDX, IDC_FILESIZE_VAL, m_ctrlFilesize);
	DDX_Control(pDX, IDC_FILEICON, m_ctrlFileIcon);
	DDX_Control(pDX, IDC_DESCRIPTION_VAL, m_ctrlDescription);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_FDG_FILENAME, m_ctrlFilename);
	DDX_Control(pDX, IDC_CATEGORIE_VAL, m_ctrlCategorie);
}


BEGIN_MESSAGE_MAP(CFDGeneral, CPropertyPage)
	//{{AFX_MSG_MAP(CFDGeneral)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_COMMENTS_BTN, OnBnClickedCommentsBtn)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFDGeneral message handlers

BOOL IsExecuteable(CString strFile)
{
	int iDot = strFile.ReverseFind('.');
	if(iDot == -1)
	{		
		return FALSE;		// no file extension found
	}
	
	CString strExt = strFile.Right(strFile.GetLength() - iDot);
	if(strExt.IsEmpty())
	{
		return FALSE;		// no file extension found
	}

	strExt.MakeUpper();
	if(strExt == ".EXE" || strExt == ".DLL")
	{
		return TRUE;		// executeable
	}

	return FALSE;			// not executeable
}

void CFDGeneral::UpdateData()
{
	if(m_pFile == NULL)
		return;

	if(!::IsWindow(GetSafeHwnd()))
		return;

	CString strFilename = m_pFile->GetFileName();

	SHFILEINFO shfi;
	memset(&shfi,0,sizeof(shfi));
	SHGetFileInfo(strFilename, FILE_ATTRIBUTE_NORMAL, &shfi, sizeof(shfi),
					SHGFI_ICON|SHGFI_USEFILEATTRIBUTES|SHGFI_TYPENAME|SHGFI_DISPLAYNAME);
	
	if(m_hFileIcon != NULL)
	{
		::DestroyIcon(m_hFileIcon);
	}
	m_hFileIcon = shfi.hIcon;
	m_ctrlFileIcon.SetIcon(m_hFileIcon);

	m_ctrlFilename.SetWindowText(MakeStringEscaped(strFilename));
	m_ctrlFiletype.SetWindowText(shfi.szTypeName);

	if(IsExecuteable(strFilename))
	{
		GetDlgItem(IDC_DESCRIPTION_LBL)->SetWindowText("Description");
		
		CFileVersionInfo fvInfo;
		fvInfo.ReadVersionInfo(strFilename);
		if(fvInfo.IsValid() )
		{
			if(fvInfo.IsVersionInfoAvailable(SFI_FILEDESCRIPTION))
			{				
				m_ctrlDescription.SetWindowText(fvInfo.GetVersionInfo(SFI_FILEDESCRIPTION));
			}
			else
			{
				m_ctrlDescription.SetWindowText(shfi.szDisplayName);
			}
		}
		else
		{
			m_ctrlDescription.SetWindowText(shfi.szDisplayName);
		}
	}
	else
	{
		GetDlgItem(IDC_DESCRIPTION_LBL)->SetWindowText("Opens with:");
		// ToDo: better solution needed	
		CString strTempFile = theApp.glob_prefs->GetTempDir() + "\\" + strFilename;
		CFile cfTemp(strTempFile, CFile::modeCreate);
		cfTemp.Close();
		char szExecuteable[MAX_PATH];
		FindExecutable(strTempFile, "", szExecuteable);
		CFile::Remove(strTempFile);

		CFileVersionInfo fvInfo;
		fvInfo.ReadVersionInfo(szExecuteable);
		if(fvInfo.IsValid() )
		{
			if(fvInfo.IsVersionInfoAvailable(SFI_FILEDESCRIPTION))
			{				
				m_ctrlDescription.SetWindowText(fvInfo.GetVersionInfo(SFI_FILEDESCRIPTION));
			}
			else
			{
				m_ctrlDescription.SetWindowText(szExecuteable);
			}
		}
		else
		{
			m_ctrlDescription.SetWindowText(szExecuteable);
		}
	}
		
	CString strCategorie;
	strCategorie.Format("%d", m_pFile->GetCategory());
	m_ctrlCategorie.SetWindowText(strCategorie);

	m_ctrlFolder.SetWindowText(m_pFile->GetOutputDir() + CString("\\"));
	m_ctrlFilesize.SetWindowText(CastItoXBytes(m_pFile->GetFileSize()));
	m_ctrlMetFile.SetWindowText(m_pFile->GetFullName());
	m_ctrlHash.SetWindowText(EncodeBase16(m_pFile->GetFileHash(), 16));
	m_ctrlPartfileStatus.SetWindowText(m_pFile->GetPartfileStatus());
}

/////////////////////////////////////////////////////////////////////////////
// CFDParts property page

IMPLEMENT_DYNCREATE(CFDParts, CPropertyPage)

CFDParts::CFDParts() : CPropertyPage(CFDParts::IDD)
{
	//{{AFX_DATA_INIT(CFDParts)
	//}}AFX_DATA_INIT
}

CFDParts::~CFDParts()
{
}

void CFDParts::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFDParts)
	DDX_Control(pDX, IDC_PARTS, m_ctrlParts);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFDParts, CPropertyPage)
	//{{AFX_MSG_MAP(CFDParts)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFDParts message handlers

BOOL CFDParts::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();

	m_ctrlParts.Init();
	UpdateData();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CFDParts::UpdateData()
{
	if(m_pFile == NULL)
		return;

	if(!::IsWindow(GetSafeHwnd()))
		return;

	int iPartCount = m_pFile->GetPartCount();
	
	m_ctrlParts.SetItemCount(iPartCount);
	
	for(int i = 0; i < iPartCount; i++)
	{		
		DWORD dwData = m_pFile->GetBytesInPart(i);
		m_ctrlParts.SetItemData(i, dwData);

		//double d = 64 * dwData / PARTSIZE;
		double d = rand() % 256;
		m_ctrlParts.SetItemState(i, (BYTE)d, FALSE);	
		
	}
	m_ctrlParts.Redraw();
}

/////////////////////////////////////////////////////////////////////////////
// CFDTransfer property page

IMPLEMENT_DYNCREATE(CFDTransfer, CPropertyPage)

CFDTransfer::CFDTransfer() : CPropertyPage(CFDTransfer::IDD)
{
	//{{AFX_DATA_INIT(CFDTransfer)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_pFile = NULL;
}

CFDTransfer::~CFDTransfer()
{
}

void CFDTransfer::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFDTransfer)
	DDX_Control(pDX, IDC_TRANSFERINGSRC_VAL, m_ctrlTransferingSources);
	DDX_Control(pDX, IDC_TRANSFERED_VAL, m_ctrlTransfered);
	DDX_Control(pDX, IDC_PARTCNT_VAL, m_ctrlPartCnt);
	DDX_Control(pDX, IDC_LASTSEENCOMPLETE_VAL, m_ctrlLastSeenComplete);
	DDX_Control(pDX, IDC_ICHRECOVERED_VAL, m_ctrlICHrecovered);
	DDX_Control(pDX, IDC_FOUNDSRC_VAL, m_ctrlFoundSources);
	DDX_Control(pDX, IDC_DATARATE_VAL, m_ctrlDatarate);
	DDX_Control(pDX, IDC_COMPLETEDSIZE_VAL, m_ctrlCompletedSize);
	DDX_Control(pDX, IDC_AVAILABLEPARTS_VAL, m_ctrlAvailableParts);
	DDX_Control(pDX, IDC_LASTRECEPTION_VAL, m_ctrlLastReception);
	DDX_Control(pDX, IDC_COMPPERC_VAL, m_ctrlCompPerc);
	DDX_Control(pDX, IDC_CORRUPTIONLOSS_VAL, m_ctrlCorruptionLoss);
	DDX_Control(pDX, IDC_COMPRESSIONGAIN_VAL, m_ctrlCompressionGain);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFDTransfer, CPropertyPage)
	//{{AFX_MSG_MAP(CFDTransfer)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFDTransfer message handlers
/////////////////////////////////////////////////////////////////////////////
// CFDAviInfo property page

void CFDTransfer::UpdateData()
{
	if(m_pFile == NULL)
		return;

	if(!::IsWindow(GetSafeHwnd()))
		return;

	CString strBuffer;

	strBuffer.Format(_T("%i"), m_pFile->GetSourceCount());
	m_ctrlFoundSources.SetWindowText(strBuffer);
	strBuffer.Format(_T("%i"), m_pFile->GetTransferingSrcCount());
	m_ctrlTransferingSources.SetWindowText(strBuffer);
	
	strBuffer.Format(_T("%i(%i)"), m_pFile->GetPartCount(), m_pFile->GetHashCount());
	m_ctrlPartCnt.SetWindowText(strBuffer);

	float fPartsPercent = 0.f;
	if(m_pFile->GetPartCount() > 0.f)
	{
		fPartsPercent = (float)((m_pFile->GetAvailablePartCount()*100) / m_pFile->GetPartCount());
	}
	strBuffer.Format(_T("%i (%.1f%%)"),m_pFile->GetAvailablePartCount(),fPartsPercent);
	m_ctrlAvailableParts.SetWindowText(strBuffer);
	
	if(m_pFile->lastseencomplete == NULL) 
	{	
		strBuffer.Format(GetResString(IDS_NEVER)); 
	}
	else
	{	
		strBuffer.Format(_T("%s"), m_pFile->localelastseencomplete());
	}
	m_ctrlLastSeenComplete.SetWindowText(strBuffer);
		
	m_ctrlTransfered.SetWindowText(CastItoXBytes(m_pFile->GetTransfered()));
	m_ctrlCompletedSize.SetWindowText(CastItoXBytes(m_pFile->GetCompletedSize()));
	
	if(m_pFile->GetPercentCompleted() >= 0.f)
	{
		strBuffer.Format(_T("%.2f "), m_pFile->GetPercentCompleted());
	}
	else
	{
		strBuffer.Format(_T("?"));
	}
	m_ctrlCompPerc.SetWindowText(strBuffer);

	if(m_pFile->GetDatarate() != (uint32)-1)
	{
		strBuffer.Format(_T("%.2f %s"), (float)m_pFile->GetDatarate()/1024, GetResString(IDS_KBYTESEC));
	}
	else
	{
		strBuffer.Format(_T("? %s"), GetResString(IDS_KBYTESEC));
	}
	m_ctrlDatarate.SetWindowText(strBuffer);
	
	if(m_pFile->GetTransfered() == 0)
	{	
		strBuffer.Format(_T("%s"), GetResString(IDS_NEVER));
	}
	else
	{
		strBuffer.Format(_T("%s"), m_pFile->localelastdowntransfer());
	}
	m_ctrlLastReception.SetWindowText(strBuffer);
	
	m_ctrlCorruptionLoss.SetWindowText(CastItoXBytes(m_pFile->GetLostDueToCorruption()));
	m_ctrlCompressionGain.SetWindowText(CastItoXBytes(m_pFile->GetGainDueToCompression()));
	m_ctrlICHrecovered.SetWindowText(CastItoXBytes(m_pFile->TotalPacketsSavedDueToICH()));
}


IMPLEMENT_DYNCREATE(CFDAviInfo, CPropertyPage)

CFDAviInfo::CFDAviInfo() : CPropertyPage(CFDAviInfo::IDD)
, m_bARoundBitrate(FALSE)
{
	//{{AFX_DATA_INIT(CFDAviInfo)
	//}}AFX_DATA_INIT

	m_pFile = NULL;
}

CFDAviInfo::~CFDAviInfo()
{
}

void CFDAviInfo::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFDAviInfo)
	DDX_Control(pDX, IDC_WIDTH_VAL, m_ctrlWidth);
	DDX_Control(pDX, IDC_VIDEOCODEC_VAL, m_ctrlVideoCodec);
	DDX_Control(pDX, IDC_VIDEOBITRATE_VAL, m_ctrlVideoBitrate);
	DDX_Control(pDX, IDC_SAMPLERATE_VAL, m_ctrlSamplerate);
	DDX_Control(pDX, IDC_HEIGHT_VAL, m_ctrlHeight);
	DDX_Control(pDX, IDC_FPS_VAL, m_ctrlFPS);
	DDX_Control(pDX, IDC_CHANNEL_VAL, m_ctrlChannel);
	DDX_Control(pDX, IDC_AUDIOCODEC_VAL, m_ctrlAudioCodec);
	DDX_Control(pDX, IDC_AUDIOBITRATE_VAL, m_ctrlAudioBitrate);
	DDX_Control(pDX, IDC_VIDEO_LBL, m_ctrlVideoLbl);
	DDX_Control(pDX, IDC_PICTURE_LBL, m_ctrlPictureLbl);
	DDX_Control(pDX, IDC_AUDIO_LBL, m_ctrlAudioLbl);
	//}}AFX_DATA_MAP
	DDX_Check(pDX, IDC_ROUNDBITRATE_BTN, m_bARoundBitrate);
	DDX_Control(pDX, IDC_FILESIZE_VAL, m_ctrlFilesize);
	DDX_Control(pDX, IDC_FILELENGTH_VAL, m_ctrlFilelength);
}


BEGIN_MESSAGE_MAP(CFDAviInfo, CPropertyPage)
	//{{AFX_MSG_MAP(CFDAviInfo)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_ROUNDBITRATE_BTN, OnBnClickedRoundbitrateBtn)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFDAviInfo message handlers

void CFDAviInfo::UpdateData()
{
	if(m_pFile == NULL)
	{	
		return;
	}

	CFile* pFile = &m_pFile->m_hpartfile;
	try
	{
		TCHAR szTemp[5];
		CString strBuffer;
		uint32 u32;
		uint16 u16;

		if(pFile == NULL)
		{	
			return;
		}
		
		pFile->Seek(8, CFile::begin);
		pFile->Read(szTemp, 4);
		szTemp[4] = 0;
		if(_tcscmp(szTemp, _T("AVI "))) // not avi
		{	
			return;
		}
		
		// filesize
		long lSize;
		pFile->Seek(4, CFile::begin);
		pFile->Read(&lSize, 4);
		strBuffer.Format(_T("%.2f MB"), ((float)lSize / 1024 / 1024));
		m_ctrlFilesize.SetWindowText(strBuffer);
		
		// header sizes
		long lAviheadersize, lVheadersize;
		pFile->Seek(28, CFile::begin);
		pFile->Read(&lAviheadersize, 4);

		long lAviheaderstart = 32;
		long lVheaderstart = lAviheaderstart + lAviheadersize + 20;

		// misc
		long lMicrosec;
		pFile->Seek(lAviheaderstart, CFile::begin);
		pFile->Read(&lMicrosec, 4);

		long lLengthInFrames;
		pFile->Seek(lAviheaderstart + 16, CFile::begin);
		pFile->Read(&lLengthInFrames, 4);

		// fps
		double dFps = (double)1000000 / (double)lMicrosec;
		strBuffer.Format(_T("%.2f"), dFps);
		m_ctrlFPS.SetWindowText(strBuffer);
				
		// length
		long lLengthInSec = (long)(lLengthInFrames / dFps);
		m_ctrlFilelength.SetWindowText(CastSecondsToHM(lLengthInSec));
		
		// video width
		pFile->Seek(lAviheaderstart + 32, CFile::begin);
		pFile->Read(&u32, 4);
		strBuffer.Format(_T("%d"), u32);
		m_ctrlWidth.SetWindowText(strBuffer);
		
		// video height
		pFile->Seek(lAviheaderstart + 36, CFile::begin);
		pFile->Read(&u32, 4);
		strBuffer.Format(_T("%d"), u32);
		m_ctrlHeight.SetWindowText(strBuffer);
		
		// video codec
		pFile->Seek(lVheaderstart + 4, CFile::begin);
		pFile->Read(szTemp, 4);
		szTemp[4] = 0;
		if(!_tcscmp(szTemp, _T("div3")) || !_tcscmp(szTemp, _T("DIV3")))
		{
			m_ctrlVideoCodec.SetWindowText(_T("DivX 3 Low-Motion"));
		}
		else if(!_tcscmp(szTemp, _T("div4")) || !_tcscmp(szTemp, _T("DIV4")))
		{	
			m_ctrlVideoCodec.SetWindowText(_T("DivX 3 High-Motion"));
		}	
		else if(!_tcscmp(szTemp, _T("divx")) || !_tcscmp(szTemp, _T("DIVX")))
		{	
			m_ctrlVideoCodec.SetWindowText(_T("DivX 4"));
		}
		else if(!_tcscmp(szTemp, _T("DX50")))
		{
			m_ctrlVideoCodec.SetWindowText(_T("DivX 5"));
		}
		else if(!_tcscmp(szTemp, _T("div2")) || !_tcscmp(szTemp, _T("DIV2")))
		{
			m_ctrlVideoCodec.SetWindowText(_T("MS MPEG4 v2"));
		}
		else if(!_tcscmp(szTemp, _T("mp43")))
		{
			m_ctrlVideoCodec.SetWindowText(_T("Microcrap MPEG4 v3"));
		}
		else if(!_tcscmp(szTemp, _T("xvid")) || !_tcscmp(szTemp, _T("XVID")))
		{
			m_ctrlVideoCodec.SetWindowText(_T("XviD"));
		}
		else
		{	
			m_ctrlVideoCodec.SetWindowText(szTemp);
		}
		
		// header sizes
		pFile->Seek(lAviheaderstart + lAviheadersize + 4, CFile::begin);
		pFile->Read(&lVheadersize, 4);

		long lAheaderstart = lVheaderstart + lVheadersize + 8;	//first databyte of audio header

		long lAstrhsize;
		pFile->Seek(lAheaderstart - 4, CFile::begin);
		pFile->Read(&lAstrhsize, 4);

		// audio codec
		pFile->Seek(lAheaderstart + lAstrhsize + 8, CFile::begin);
		pFile->Read(&u16, 2);
		switch(u16)
		{
			case 0:
			case 1:
				m_ctrlAudioCodec.SetWindowText(_T("PCM"));
				break;
			case 353:
				m_ctrlAudioCodec.SetWindowText(_T("DivX;-) Audio"));
				break;
			case 85:
				m_ctrlAudioCodec.SetWindowText(_T("MPEG Layer 3"));
				break;
			case 8192:
				m_ctrlAudioCodec.SetWindowText(_T("AC3-Digital"));
				break;
			default:
				strBuffer.Format(_T("Unknown (%d)"), u16);
				m_ctrlAudioCodec.SetWindowText(strBuffer);
				break;
		}			
			
		// audio channel
		pFile->Seek(lAheaderstart + 2 + lAstrhsize + 8, CFile::begin);
		pFile->Read(&u16, 2);
		switch(u16)
		{
			case 1:
				m_ctrlChannel.SetWindowText(_T("1 (mono)"));
				break;
			case 2:
				m_ctrlChannel.SetWindowText(_T("2 (stereo)"));
				break;
			case 5:
				m_ctrlChannel.SetWindowText(_T("5.1 (surround)"));
				break;
			default:
				strBuffer.Format(_T("%d"), u16);
				m_ctrlChannel.SetWindowText(strBuffer);
				break;
		}
			
		// audio samplerate
		pFile->Seek(lAheaderstart + 4 + lAstrhsize + 8, CFile::begin);
		pFile->Read(&u32, 2);
		strBuffer.Format(_T("%d"), u32);
		m_ctrlSamplerate.SetWindowText(strBuffer);

		// audio bitrate
		pFile->Seek(lAheaderstart + 8 + lAstrhsize + 8, CFile::begin);
		pFile->Read(&m_lAbitrate, 4);
		OnBnClickedRoundbitrateBtn();

		// video bitrate
		strBuffer.Format(_T("%d Kbit/s"), (lSize / lLengthInSec - m_lAbitrate) / 128);
		m_ctrlVideoBitrate.SetWindowText(strBuffer);

	}
	catch(CFileException* error)
	{
		OUTPUT_DEBUG_TRACE();
		error->Delete();	//memleak fix
		return;
	}
}

void CFDAviInfo::Localize()
{

}

/////////////////////////////////////////////////////////////////////////////
// CFDSrcNames property page

IMPLEMENT_DYNCREATE(CFDSrcNames, CPropertyPage)

CFDSrcNames::CFDSrcNames() : CPropertyPage(CFDSrcNames::IDD)
{
	//{{AFX_DATA_INIT(CFDSrcNames)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_pFile = NULL;
}

CFDSrcNames::~CFDSrcNames()
{
}

void CFDSrcNames::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFDSrcNames)
	// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_FDS_TAKEOVER, m_ctrlTakeOver);
	DDX_Control(pDX, IDC_CLEANUP, m_ctrlCleanUp);
	DDX_Control(pDX, IDC_RENAME, m_ctrlRename);
	DDX_Control(pDX, IDC_FILENAME, m_ctrlFilename);
}


BEGIN_MESSAGE_MAP(CFDSrcNames, CPropertyPage)
	//{{AFX_MSG_MAP(CFDSrcNames)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_RENAME, OnBnClickedRename)
	ON_BN_CLICKED(IDC_CLEANUP, OnBnClickedCleanup)
	ON_BN_CLICKED(IDC_FDS_TAKEOVER, OnBnClickedFdsTakeover)
	ON_NOTIFY(LVN_COLUMNCLICK, IDC_LISTCTRLFILENAMES, OnLvnColumnclick)
	ON_NOTIFY(NM_DBLCLK, IDC_LISTCTRLFILENAMES, OnNMDblclkList)
	ON_NOTIFY(NM_RCLICK, IDC_LISTCTRLFILENAMES, OnNMRclickList)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFDSrcNames message handlers

void CFDSrcNames::UpdateData()
{
	if(m_pFile == NULL)
		return;
	
	if(!::IsWindow(GetSafeHwnd()))
		return;

	bool bEnable =	m_pFile->GetStatus() == PS_COMPLETE		||
					m_pFile->GetStatus() == PS_COMPLETING	?	false : true;

	m_ctrlRename.EnableWindow(bEnable);
	m_ctrlCleanUp.EnableWindow(bEnable);
	m_ctrlTakeOver.EnableWindow(bEnable);	
}

void CFDSrcNames::FillSourcenameList() 
{
	CUpDownClient* cur_src;
	CListCtrl* pmyListCtrl; 
	LVFINDINFO info; 
	info.flags = LVFI_STRING; 
	int itempos; 
	int namecount;

	CString nameCountStr;
	pmyListCtrl = (CListCtrl*)GetDlgItem(IDC_SOURCENAMES); 
	if(pmyListCtrl->GetHeaderCtrl()->GetItemCount() < 2) 
	{
		pmyListCtrl->DeleteColumn(0); 
		pmyListCtrl->InsertColumn(0, GetResString(IDS_DL_FILENAME), LVCFMT_LEFT, 340, -1); 
		pmyListCtrl->InsertColumn(1, GetResString(IDS_DL_SOURCES), LVCFMT_LEFT, 60, 1); 
	}

	//v- eklmn: bugfix(16): don't show empty string in FileDetails
	CString strFileName; 
	POSITION pos1, pos2;
	pmyListCtrl->DeleteAllItems(); 
	for(int sl=0;sl<SOURCESSLOTS;sl++) 
	{
		if(!m_pFile->srclists[sl].IsEmpty())
		{
			for(pos1 = m_pFile->srclists[sl].GetHeadPosition(); (pos2 = pos1) != NULL;) 
			{
				m_pFile->srclists[sl].GetNext(pos1);
				cur_src = m_pFile->srclists[sl].GetAt(pos2);

				strFileName = cur_src->GetClientFilename(); 
				if(strFileName.GetLength() != 0) 
				{ 
					info.psz = strFileName;
					if((itempos=pmyListCtrl->FindItem(&info, -1)) == -1) 
					{ 
						pmyListCtrl->InsertItem(0, strFileName); 
						pmyListCtrl->SetItemText(0, 1, _T("1")); 
						pmyListCtrl->SetItemData(0, 1); 
					} 
					else 
					{ 
						namecount = _tstoi(pmyListCtrl->GetItemText(itempos, 1)); 
						namecount ++; 
						nameCountStr.Format(_T("%i"), namecount); 
						pmyListCtrl->SetItemText(itempos, 1, nameCountStr.GetString());
						pmyListCtrl->SetItemData(itempos, namecount); 
					} 
					pmyListCtrl->SortItems(CompareListNameItems, 11); 
					m_bSortAscending[0] =true;
					m_bSortAscending[1] =false;
				} 
			} 
		}
	}
 }

void CFDSrcNames::OnBnClickedRename()
{
	CString strNewFileName; 
	m_ctrlFilename.GetWindowText(strNewFileName);

	m_pFile->SetFileName(strNewFileName.GetBuffer()); 
	m_pFile->SavePartFile(); 

	CFileDetails* pParent = (CFileDetails*)GetParent();
	if(pParent != NULL)
	{
		pParent->UpdateData();
	}
}

void CFDSrcNames::OnBnClickedCleanup()
{
	CString strFilename = "";
	m_ctrlFilename.ReplaceSel(strFilename.GetBuffer());
	m_ctrlFilename.GetWindowText(strFilename);
	m_ctrlFilename.SetWindowText(CleanupFilename(strFilename));
}

void CFDSrcNames::OnBnClickedFdsTakeover()
{
	CListCtrl* pmyListCtrl; 
	int itemPosition; 

	pmyListCtrl = (CListCtrl*)GetDlgItem(IDC_SOURCENAMES);

	if(pmyListCtrl->GetSelectedCount() > 0) 
	{
		POSITION pos = pmyListCtrl->GetFirstSelectedItemPosition(); 
		itemPosition = pmyListCtrl->GetNextSelectedItem(pos); 
		GetDlgItem(IDC_FILENAME)->SetWindowText(pmyListCtrl->GetItemText(itemPosition,0));
	} 
}

void CFDSrcNames::OnLvnColumnclick(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	
	m_bSortAscending[pNMLV->iSubItem] = !m_bSortAscending[pNMLV->iSubItem];
	//SetSortArrow(pNMLV->iSubItem, m_SortAscending[pNMLV->iSubItem]);

	CListCtrl* pmyListCtrl; 
	pmyListCtrl = (CListCtrl*)GetDlgItem(IDC_SOURCENAMES);

	pmyListCtrl->SortItems(&CompareListNameItems, pNMLV->iSubItem + ((m_bSortAscending[pNMLV->iSubItem]) ? 0 : 10));

	*pResult = 0;
}

void CFDSrcNames::OnNMDblclkList(NMHDR *pNMHDR, LRESULT *pResult)
{
	OnBnClickedFdsTakeover();
	*pResult = 0;
}

void CFDSrcNames::OnNMRclickList(NMHDR *pNMHDR, LRESULT *pResult)
{
	CListCtrl* pmyListCtrl; 
	pmyListCtrl = (CListCtrl*)GetDlgItem(IDC_SOURCENAMES);
	POINT point;
	::GetCursorPos(&point);
	CTitleMenu	popupMenu;

	UINT flag;
	flag = MF_STRING;
	if(pmyListCtrl->GetSelectionMark() == -1) 
	{
		flag = MF_GRAYED;
	}

	popupMenu.CreatePopupMenu();
	popupMenu.AppendMenu(flag,MP_MESSAGE, GetResString(IDS_TAKEOVER));
	popupMenu.AppendMenu(MF_STRING, MP_RESTORE, GetResString(IDS_SV_UPDATE));
	popupMenu.TrackPopupMenu(TPM_LEFTALIGN |TPM_RIGHTBUTTON, point.x, point.y, this);
	popupMenu.DestroyMenu();

	*pResult = 0;
}

BOOL CFDSrcNames::OnCommand(WPARAM wParam,LPARAM lParam )
{
	CListCtrl* pmyListCtrl; 
	pmyListCtrl = (CListCtrl*)GetDlgItem(IDC_SOURCENAMES);
	
	if(pmyListCtrl->GetSelectionMark() != -1)
	{
		switch (wParam)
		{
			case MP_MESSAGE:
			{
				OnBnClickedFdsTakeover();
				return true;
			}
			case MP_RESTORE: 
			{
				FillSourcenameList();
				return true;
			}
		}
	}

	if(wParam == 2)
	{
		CPropertyPage::OnOK();
		return TRUE;
	}

	return CPropertyPage::OnCommand(wParam, lParam);
}

int CALLBACK CFDSrcNames::CompareListNameItems(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{ 
	switch(lParamSort)
	{
		case 1: 
			return (lParam1 - lParam2); 
			break;
		
		case 11: 
			return (lParam2 - lParam1); 
			break;
		
		default: 
			return 0;
	}
} 

void CFDGeneral::OnBnClickedCommentsBtn()
{
	CCommentDialogLst dialog(m_pFile); 
	dialog.DoModal();
}

BOOL CFDAviInfo::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	m_bARoundBitrate = TRUE;
	CPropertyPage::UpdateData(FALSE);
	Localize();
	UpdateData();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CFDAviInfo::OnBnClickedRoundbitrateBtn()
{
	if(m_lAbitrate != 0)
	{
		CPropertyPage::UpdateData();

		if(m_bARoundBitrate)
		{
			long t = m_lAbitrate / (1024 / 8);
			if(t >= 246 && t <= 260)
			{	
				m_ctrlAudioBitrate.SetWindowText(_T("256 Kbit/s"));
			}	
			else if(t >= 216 && t <= 228)
			{
				m_ctrlAudioBitrate.SetWindowText(_T("224 Kbit/s"));
			}
			else if(t >= 187 && t <= 196)
			{
				m_ctrlAudioBitrate.SetWindowText(_T("192 Kbit/s"));
			}
			else if(t >= 156 && t <= 164)
			{	
				m_ctrlAudioBitrate.SetWindowText(_T("160 Kbit/s"));
			}
			else if(t >= 124 && t <= 132)
			{	
				m_ctrlAudioBitrate.SetWindowText(_T("128 Kbit/s"));
			}
			else if(t >= 108 && t <= 116)
			{	
				m_ctrlAudioBitrate.SetWindowText(_T("112 Kbit/s"));
			}
			else if(t >= 92 && t <= 100)
			{	
				m_ctrlAudioBitrate.SetWindowText(_T("96 Kbit/s"));
			}
			else if(t >= 60 && t <= 68)
			{	
				m_ctrlAudioBitrate.SetWindowText(_T("64 Kbit/s"));
			}
			else
			{
				CString strBuffer;
				strBuffer.Format(_T("%d Kbit/s"), t);
				m_ctrlAudioBitrate.SetWindowText(strBuffer);
			}
		}
		else
		{
			CString strBuffer;
			strBuffer.Format(_T("%d Kbit/s"), m_lAbitrate / (1024 / 8));
			m_ctrlAudioBitrate.SetWindowText(strBuffer);
		}
	}
	else
	{	
		m_ctrlAudioBitrate.SetWindowText(_T(""));
	}
}

BOOL CFDGeneral::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	UpdateData();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CFDTransfer::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	UpdateData();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CFDSrcNames::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	UpdateData();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}
