#pragma once

#include "preferences.h"
#include "afxwin.h"
#include "Loggable.h"
#include "3dpreviewcontrol.h"
#include "afxcmn.h"

// CPPgGeneral dialog

class CPPgGeneral : public CPropertyPage, public CLoggable
{
	DECLARE_DYNAMIC(CPPgGeneral)

public:
	CPPgGeneral();
	virtual ~CPPgGeneral();

	void SetPrefs(CPreferences* in_prefs) {	app_prefs = in_prefs; }
	void Localize(void);

// Dialog Data
	enum { IDD = IDD_PPG_GENERAL };
protected:
	CPreferences *app_prefs;

	bool m_bModified;
	void SetModified(BOOL bChanged = TRUE)
	{
		m_bModified = bChanged;
		CPropertyPage::SetModified(bChanged);
	}

	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
//	static CBarShader s_preview;
	DECLARE_MESSAGE_MAP()
private:
	void LoadSettings(void);
	void LoadLanguagesCombo(void);
	void DrawPreview();		//Cax2 - aqua bar
public:
	virtual BOOL OnInitDialog();
	virtual BOOL OnApply();

	afx_msg void OnSettingsChange()		{SetModified();}
	afx_msg void OnPaint();	
	afx_msg void On3DDepth(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnBnClickedEditWebservices();
protected:		
	CString userNick;
	CString tooltipDelay;
	BOOL beepOnErrors;
	BOOL showSplashscreen;
	BOOL allowMultipleInstances;
	BOOL onlineSignature;
	BOOL writeLogToFile;
	BOOL debugLog;
	BOOL doubleClickClientDetails;
	int mainProcess;
private:
	CSliderCtrl threeDSlider;
	CComboBox languageCombo;
	C3DPreviewControl m_3DPreview;
	CEdit userNickEdit;
	CButton beepOnErrorsCheck;
	CButton showSplashscreenCheck;
	CButton allowMultipleInstancesCheck;
	CButton onlineSignatureCheck;
	CButton writeLogToFileCheck;
	CButton debugLogCheck;
	CButton doubleClickClientDetailsCheck;
	CButton standardProcessRadio;
	CButton highProcessRadio;
	CButton webSvEditButton;
	CStatic nickDesc;
	CStatic languageDesc;
	CStatic miscDesc;
	CStatic tooltipDelayDesc;
	CStatic threeDDepDesc;
	CStatic mainProcessDesc;
};
