 // PPgWindow.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PPgWindow.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// CPPgWindow dialog

IMPLEMENT_DYNAMIC(CPPgWindow, CPropertyPage)
CPPgWindow::CPPgWindow()
	: CPropertyPage(CPPgWindow::IDD)
	, startMin(FALSE)
	, minTray(FALSE)
	, closeToTray(FALSE)
	, promptOnExit(FALSE)
	, bringToForeground(FALSE)
	, autoTakeEd2kLinks(FALSE)
	, showRateOnTitle(FALSE)
	, showSpeedMeterOnToolbar(FALSE)
	, showA4AF(FALSE)
	, showAvgDatarate(FALSE)
	, showFileTypeIcons(FALSE)
	, showTransferredOnCompleted(FALSE)
	, showDownloadPercentage(FALSE)
	, usedFontDesc(_T(""))
{
}

CPPgWindow::~CPPgWindow()
{
}

void CPPgWindow::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Check(pDX, IDC_STARTMIN, startMin);
	DDX_Check(pDX, IDC_MINTRAY, minTray);
	DDX_Check(pDX, IDC_CB_TBN_CLOSETOTRAY, closeToTray);
	DDX_Check(pDX, IDC_EXIT, promptOnExit);
	DDX_Check(pDX, IDC_BRINGTOFOREGROUND, bringToForeground);
	DDX_Check(pDX, IDC_AUTOTAKEED2KLINKS, autoTakeEd2kLinks);
	DDX_Check(pDX, IDC_SHOWRATEONTITLE, showRateOnTitle);
	DDX_Check(pDX, IDC_TBSPEEDMETER, showSpeedMeterOnToolbar);
	DDX_Check(pDX, IDC_A4AF, showA4AF);
	DDX_Check(pDX, IDC_SHOWAVGDATARATE, showAvgDatarate);
	DDX_Check(pDX, IDC_SHOWFTYPE, showFileTypeIcons);
	DDX_Check(pDX, IDC_SHOWTRANFONCMPLT, showTransferredOnCompleted);
	DDX_Check(pDX, IDC_SHOWDWLPERCENTAGE, showDownloadPercentage);
	DDX_Text(pDX, IDC_USEDFONT_LBL, usedFontDesc);
	DDX_Control(pDX, IDC_ED2KFIX, ed2kFixButton);
	DDX_Control(pDX, IDC_USEDFONT, fontPreviewCombo);
	DDX_Control(pDX, IDC_USEDFONTSIZE, fontSizeCombo);
	DDX_Control(pDX, IDC_STARTMIN, startMinCheck);
	DDX_Control(pDX, IDC_MINTRAY, minTrayCheck);
	DDX_Control(pDX, IDC_CB_TBN_CLOSETOTRAY, closeToTrayCheck);
	DDX_Control(pDX, IDC_EXIT, promptOnExitCheck);
	DDX_Control(pDX, IDC_BRINGTOFOREGROUND, bringToForegroundCheck);
	DDX_Control(pDX, IDC_AUTOTAKEED2KLINKS, autoTakeEd2kLinksCheck);
	DDX_Control(pDX, IDC_SHOWRATEONTITLE, showRateOnTitleCheck);
	DDX_Control(pDX, IDC_TBSPEEDMETER, showSpeedMeterOnToolbarCheck);
	DDX_Control(pDX, IDC_A4AF, showA4AFCheck);
	DDX_Control(pDX, IDC_SHOWAVGDATARATE, showAvgDatarateCheck);
	DDX_Control(pDX, IDC_SHOWFTYPE, showFileTypeIconsCheck);
	DDX_Control(pDX, IDC_SHOWTRANFONCMPLT, showTransferredOnCompletedCheck);
	DDX_Control(pDX, IDC_SHOWDWLPERCENTAGE, showDownloadPercentageCheck);
}

BEGIN_MESSAGE_MAP(CPPgWindow, CPropertyPage)
	ON_BN_CLICKED(IDC_STARTMIN, OnEnChangeStartMin)
	ON_BN_CLICKED(IDC_MINTRAY, OnBnClickedMintray)
	ON_BN_CLICKED(IDC_EXIT, OnBnClickedExit)
	ON_BN_CLICKED(IDC_BRINGTOFOREGROUND, OnBnClickedBringtoforeground)
	ON_BN_CLICKED(IDC_CB_TBN_CLOSETOTRAY, OnBnClickedCbTbnClosetotray)
	ON_CBN_SELCHANGE(IDC_USEDFONT, OnCbnSelchangeUsedFont)
	ON_CBN_SELCHANGE(IDC_USEDFONTSIZE, OnCbnSelchangeUsedfontsize)
	ON_BN_CLICKED(IDC_ED2KFIX, OnBnClickedEd2kfix)
	ON_BN_CLICKED(IDC_AUTOTAKEED2KLINKS, OnBnClickedAutoTakeED2KLinks)
	ON_BN_CLICKED(IDC_SHOWRATEONTITLE, OnBnClickedShowRateOnTitle)
	ON_BN_CLICKED(IDC_TBSPEEDMETER, OnBnClickedSpeedMeter)
	ON_BN_CLICKED(IDC_A4AF, OnBnClickedA4AF)
	ON_BN_CLICKED(IDC_SHOWAVGDATARATE, OnBnClickedAvgDatarate)
	ON_BN_CLICKED(IDC_SHOWFTYPE, OnBnClickedShowFileType)
	ON_BN_CLICKED(IDC_SHOWTRANFONCMPLT, OnBnClickedTransferredOnCompleted)
	ON_BN_CLICKED(IDC_SHOWDWLPERCENTAGE, OnBnClickedDownloadPercentage)
END_MESSAGE_MAP()

BOOL CPPgWindow::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	fontPreviewCombo.m_style = CFontPreviewCombo::NAME_ONLY;
	fontPreviewCombo.Init();

	fontSizeCombo.AddString(_T("8"));
	fontSizeCombo.AddString(_T("10"));
	fontSizeCombo.AddString(_T("12"));
	ed2kFixButton.EnableWindow(!CheckIsRegistrySet());
	LoadSettings();
	Localize();

	return TRUE;
}

void CPPgWindow::LoadSettings(void)
{
	startMin = app_prefs->GetStartMinimized();		
	minTray = app_prefs->DoMinToTray();
	promptOnExit = app_prefs->IsConfirmExitEnabled();
	bringToForeground = app_prefs->IsBringToFront();
	closeToTray = app_prefs->GetCloseToTray();	
	autoTakeEd2kLinks = app_prefs->AutoTakeED2KLinks();
	showRateOnTitle = app_prefs->ShowRatesOnTitle();		
	showSpeedMeterOnToolbar = app_prefs->GetShowToolbarSpeedMeter();
	showA4AF = app_prefs->IsA4AFStringEnabled();
	showAvgDatarate = app_prefs->GetShowAverageDatarate();
	showFileTypeIcons = app_prefs->ShowFileTypeIcon();
	showTransferredOnCompleted = app_prefs->IsTransferredOnCompleted();
	showDownloadPercentage = app_prefs->GetUseDwlPercentage();
	
	int FontIdx = fontPreviewCombo.FindStringExact(0,app_prefs->GetUsedFont());
	if(FontIdx == LB_ERR)
       fontPreviewCombo.SetCurSel(0);
	else
       fontPreviewCombo.SetCurSel(FontIdx);
	fontSizeCombo.SetCurSel(0);
	if (app_prefs->GetFontSize())
		fontSizeCombo.SetCurSel((int)((app_prefs->GetFontSize()-80)/20)); // FontSize Cax2

	UpdateData(FALSE);

	SetModified(FALSE);	// FoRcHa
}

BOOL CPPgWindow::OnApply()
{
	if(m_bModified)
	{
		UpdateData(TRUE);
		
		int8 mintotray_old = app_prefs->DoMinToTray(); // #zegzav (add)
		int8 ShowFileTypeIcon_old = app_prefs->ShowFileTypeIcon(); // DonGato

		app_prefs->SetStartMinimized(startMin);
		app_prefs->SetMinToTray(minTray);
		app_prefs->SetConfirmExitEnabled(promptOnExit);
		app_prefs->SetBringToFront(bringToForeground);
		app_prefs->SetCloseToTray(closeToTray);
		app_prefs->SetAutoTakeED2KLinks(autoTakeEd2kLinks); // DonGato
		app_prefs->SetRatesOnTitle(showRateOnTitle);
		app_prefs->SetShowToolbarSpeedMeter(showSpeedMeterOnToolbar);
		app_prefs->SetA4AFStringEnabled(showA4AF);
		app_prefs->SetShowAverageDatarate(showAvgDatarate);
		app_prefs->SetShowFileTypeIcon(showFileTypeIcons);
		app_prefs->SetTransferredOnCompleted(showTransferredOnCompleted);
		app_prefs->SetUseDwlPercentage(showDownloadPercentage);

		// #zegzav
        if (mintotray_old != (int8)app_prefs->DoMinToTray())
		{
            theApp.emuledlg->TraySetMinimizeToTray((int8)app_prefs->DoMinToTray());
    		theApp.emuledlg->TrayMinimizeToTrayChanged();
        }
   
		// DonGato
        if (ShowFileTypeIcon_old != (int8)app_prefs->ShowFileTypeIcon())
		{
            theApp.emuledlg->transferwnd.m_wndDownloadList.Invalidate();
            theApp.emuledlg->sharedfileswnd.sharedfilesctrl.Invalidate();
        }

		CString buffer;
		fontPreviewCombo.GetWindowText(buffer);
		app_prefs->SetUsedFont(buffer);
		app_prefs->SetFontSize(fontSizeCombo.GetCurSel()*20 + 80);	// FontSize Cax2
		// Cax2 - Font update
		theApp.emuledlg->m_DefaultFont.DeleteObject(); 
		theApp.emuledlg->m_DefaultFont.CreatePointFont(app_prefs->GetFontSize(),buffer); 
      	theApp.emuledlg->serverwnd.InitFont(); 
      	theApp.emuledlg->ircwnd.InitFont(); 
      	theApp.emuledlg->chatwnd.chatselector.chatout.SetFont(&theApp.emuledlg->m_DefaultFont); 

		theApp.emuledlg->transferwnd.m_wndDownloadList.SetStyle();
		theApp.emuledlg->toolbar.ShowSpeedMeter(app_prefs->GetShowToolbarSpeedMeter());

		SetModified(FALSE);

		if (!theApp.glob_prefs->ShowRatesOnTitle()) {
			CString buffer;
			buffer.Format(_T("eMule Plus v%s"),CURRENT_VERSION_LONG);
			theApp.emuledlg->SetWindowText(buffer);
		}
	}

	return CPropertyPage::OnApply();
}

void CPPgWindow::Localize(void)
{
	if(::IsWindow(m_hWnd))
	{
		SetWindowText(GetResString(IDS_PW_WINDOW));
		startMinCheck.SetWindowText(GetResString(IDS_PREF_STARTMIN));	
		minTrayCheck.SetWindowText(GetResString(IDS_PW_TRAY));
		promptOnExitCheck.SetWindowText(GetResString(IDS_PW_PROMPT));
		bringToForegroundCheck.SetWindowText(GetResString(IDS_PW_FRONT));
		closeToTrayCheck.SetWindowText(GetResString(IDS_PW_TBN_CLOSETOTRAY));
		usedFontDesc = GetResString(IDS_USEDFONT_LBL);
		ed2kFixButton.SetWindowText(GetResString(IDS_ED2KLINKFIX));
		autoTakeEd2kLinksCheck.SetWindowText(GetResString(IDS_AUTOTAKEED2KLINKS));
		showRateOnTitleCheck.SetWindowText(GetResString(IDS_SHOWRATEONTITLE));
		showSpeedMeterOnToolbarCheck.SetWindowText(GetResString(IDS_PW_SHOWTOOLBARSPEEDMETER));
		showA4AFCheck.SetWindowText(GetResString(IDS_A4AF));
		showAvgDatarateCheck.SetWindowText(GetResString(IDS_SHOWAVGDATARATE));
		showFileTypeIconsCheck.SetWindowText(GetResString(IDS_SHOWFTYPE));
		showTransferredOnCompletedCheck.SetWindowText(GetResString(IDS_SHOWTRANFONCMPLT));
		showDownloadPercentageCheck.SetWindowText(GetResString(IDS_SHOWDWLPERCENTAGE));
		UpdateData(FALSE);
	}
}

void CPPgWindow::OnBnClickedEd2kfix()
{
	Ask4RegFix();
	ed2kFixButton.EnableWindow(!CheckIsRegistrySet());
}
