// #zegzav:pastcomment

#pragma once
#include "types.h"


class CPastComment
{
	public:
		CPastComment();
		CPastComment(uchar client[16]);
		CPastComment(uchar client[16], const CString &strClientName);
		CPastComment(uchar client[16], const CString &strClientName, const CString &strFileName, const CString &strComment, int8 nRate);
		~CPastComment();

		const CString &GetClientName() const;
		void SetFileName(const CString &strFileName);
		const CString &GetFileName() const;
		void SetComment(const CString &strComment);
		const CString &GetComment() const;
		void SetRate(int8 nRate);
		int8 GetRate() const;

		bool operator==(const CPastComment &pc) const;

	protected:
		uchar m_ClientHash[16];
		CString m_strClientName;
		CString m_strFileName;
		CString m_strComment;
		int8 m_nRate;
};

class CPastCommentList : public CList<CPastComment, CPastComment&>
{
	public:
		CPastCommentList();
		~CPastCommentList();

		void Add(uchar client[16], const CString &strClientName, const CString &strFileName, const CString &strComment, int8 nRate);
		void Remove(uchar client[16]);
		int GetCount() const;

		bool GetCommentRate(uchar client[16], CString *pstrComment, int8 *pnRate) const;
		const CString &GetFileName(uchar client[16]);
		const CString &GetComment(uchar client[16]);
		int8 GetRate(uchar client[16]);

	protected:
		// POSITION Find(uchar client[16]) const;
};




inline CPastComment::~CPastComment()
{
}

inline const CString &CPastComment::GetClientName() const
{
	return m_strClientName;
}

inline void CPastComment::SetComment(const CString &strComment)
{
	m_strComment= strComment;
}

inline const CString &CPastComment::GetComment() const
{ 
	return m_strComment; 
}

inline void CPastComment::SetFileName(const CString &strFileName)
{
	m_strFileName= strFileName;
}

inline const CString &CPastComment::GetFileName() const
{ 
	return m_strFileName; 
}

inline void CPastComment::SetRate(int8 nRate)
{ 
	m_nRate= nRate; 
}

inline int8 CPastComment::GetRate() const
{ 
	return m_nRate; 
}

inline CPastCommentList::CPastCommentList()
{
}

inline CPastCommentList::~CPastCommentList()
{
}
