//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


// SearchDlg.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "SearchDlg.h"
#include "packets.h"
#include "server.h"
#include "opcodes.h"
#include "otherfunctions.h"
#include "ED2KLink.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


// CSearchDlg dialog

IMPLEMENT_DYNAMIC(CSearchDlg, CDialog)
CSearchDlg::CSearchDlg(CWnd* pParent /*=NULL*/)
: CResizableDialog(CSearchDlg::IDD, pParent)
{
	m_nSearchID = 0;
	searchpacket	=	NULL;
}

CSearchDlg::~CSearchDlg()
{
	EMULE_TRY
	if ( searchpacket )
		delete searchpacket;
	EMULE_CATCH2
}

BOOL CSearchDlg::OnInitDialog()
{
	EMULE_TRY
	CResizableDialog::OnInitDialog();
	theApp.searchlist->SetOutputWnd(&searchlistctrl);
	searchlistctrl.Init(theApp.searchlist);
	searchprogress.SetStep(1);
	global_search_timer = 0;
	globsearch = false;

	m_ctrlSearchFrm.Init(IDI_NORMALSEARCH, &theApp.emuledlg->m_ThemeHelper);
	m_ctrlDirectDlFrm.Init(IDI_DIRECTDOWNLOAD, &theApp.emuledlg->m_ThemeHelper);	
	oldSearchLstIcon = GetSearchLstStatic()->SetIcon(GetSearchLstIcon());	//[TwoBottle Mod]

	searchselect.ShowWindow(SW_HIDE);
	m_BoxImageList.Create(13,13,ILC_COLOR32|ILC_MASK,0,10);
	m_BoxImageList.SetBkColor(CLR_NONE);
	m_BoxImageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_SCH_SERVER),13,13));
	m_BoxImageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_SCH_GLOBAL),13,13));
	m_BoxImageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_SCH_FILEDONKEY),13,13));
	m_BoxImageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_SCH_JIGLE),13,13));

	m_ImageList.Create(16,16,ILC_COLOR32|ILC_MASK,0,10);
	m_ImageList.SetBkColor(CLR_NONE);
	m_ImageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_NORMALSEARCH),16,16));
	LoadImgLstIcon(NULL,0,0); // delete temp-icon
	searchselect.SetImageList(&m_ImageList);

	AddAnchor(IDC_SEARCH_FRM, TOP_LEFT);
	AddAnchor(IDC_SNAME_LBL, TOP_LEFT);
	AddAnchor(IDC_SEARCHNAME, TOP_LEFT);
	AddAnchor(IDC_SEARCHNAME_NOT, TOP_LEFT);
	AddAnchor(IDC_STYPE_LBL, TOP_LEFT);
	AddAnchor(IDC_TypeSearch, TOP_LEFT);
	AddAnchor(IDC_SMETHOD_LBL, TOP_LEFT);
	AddAnchor(IDC_METHOD, TOP_LEFT);

	AddAnchor(IDC_DDOWN_FRM, TOP_LEFT, TOP_RIGHT);
	AddAnchor(IDC_ED2KLINK_LBL, TOP_LEFT);
	AddAnchor(IDC_ELINK, TOP_LEFT, TOP_RIGHT);

	AddAnchor(IDC_STARTS, TOP_RIGHT);
	AddAnchor(IDC_CANCELS, TOP_RIGHT);
	AddAnchor(IDC_CLEARALL, TOP_RIGHT);

	AddAnchor(IDC_SEARCHLST_ICO, TOP_LEFT);
	AddAnchor(IDC_RESULTS_LBL, TOP_LEFT);
	AddAnchor(IDC_SEARCHLIST, TOP_LEFT, BOTTOM_RIGHT);

	AddAnchor(IDC_SDOWNLOAD, BOTTOM_LEFT);
	AddAnchor(IDC_PROGRESS1, BOTTOM_LEFT, BOTTOM_RIGHT);

	AddAnchor(searchselect.m_hWnd,TOP_LEFT,TOP_RIGHT);
	AddAnchor(IDC_DOWNLOAD_ALL_ED2K, BOTTOM_LEFT); //<<-- enkeyDEV(Ottavio84) -Download all ed2ks in clipboard-
	AddAnchor(IDC_STATIC_DLTOof, BOTTOM_LEFT);
	AddAnchor(IDC_CATTAB2, BOTTOM_LEFT, BOTTOM_RIGHT);

	Localize();
	return true;
	EMULE_CATCH
	return false;
}

void CSearchDlg::DoDataExchange(CDataExchange* pDX)
{
	CResizableDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SEARCHLIST, searchlistctrl);
	DDX_Control(pDX, IDC_PROGRESS1, searchprogress);
	DDX_Control(pDX, IDC_METHOD, methodbox);
	DDX_Control(pDX, IDC_TypeSearch, Stypebox);
	DDX_Control(pDX, IDC_TAB1, searchselect);
	DDX_Control(pDX, IDC_SEARCH_FRM, m_ctrlSearchFrm);
	DDX_Control(pDX, IDC_DDOWN_FRM, m_ctrlDirectDlFrm);
	DDX_Control(pDX, IDC_CATTAB2, m_cattabs);
}


BEGIN_MESSAGE_MAP(CSearchDlg, CResizableDialog)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_SEARCH_RESET, OnBnClickedSearchReset)
	ON_BN_CLICKED(IDC_STARTS, OnBnClickedStarts)
	ON_BN_CLICKED(IDC_CANCELS, OnBnClickedCancels)
	ON_BN_CLICKED(IDC_CLEARALL, OnBnClickedClearall)
	ON_BN_CLICKED(IDC_SDOWNLOAD, OnBnClickedSdownload)
	ON_BN_CLICKED(IDC_DOWNLOAD_ALL_ED2K, OnBnClickedDownloadAllEd2k)
	ON_EN_KILLFOCUS(IDC_EDITSEARCHMIN, OnChangeMin)
	ON_EN_KILLFOCUS(IDC_EDITSEARCHMAX, OnChangeMax)
	ON_NOTIFY(NM_DBLCLK, IDC_SEARCHLIST, OnNMDblclkSearchlist)
	ON_NOTIFY(TCN_SELCHANGE, IDC_TAB1, OnTcnSelchangeTab1)
	//ON_CBN_SELCHANGE(IDC_TypeSearch, OnEnChangeSearchname) // EC 08.07.03
	ON_CBN_SELCHANGE(IDC_METHOD, OnEnChangeMethod)
	ON_MESSAGE(WM_CLOSETAB, OnCloseTab)
	ON_MESSAGE(WM_SHOWWINDOW, OnShowWindow)
	ON_WM_DESTROY()
END_MESSAGE_MAP()


// CSearchDlg message handlers
void CSearchDlg::OnChangeMin()
{
	OnChangeSize(true);
}
void CSearchDlg::OnChangeMax()
{
	OnChangeSize(false);
}

void CSearchDlg::OnChangeSize(bool changedMin)
{
	EMULE_TRY
	CString sMin, sMax;
	GetDlgItem(IDC_EDITSEARCHMIN)->GetWindowText(sMin);
	GetDlgItem(IDC_EDITSEARCHMAX)->GetWindowText(sMax);
	if (_tstol(sMin)>2047)
		GetDlgItem(IDC_EDITSEARCHMIN)->SetWindowText(_T("2047"));
	if (_tstol(sMax)>2048)
		GetDlgItem(IDC_EDITSEARCHMAX)->SetWindowText(_T("2048"));
	if (_tstoi(sMax)-_tstoi(sMin)<1 && sMax!="")
	{
		if (changedMin)
		{
			GetDlgItem(IDC_EDITSEARCHMAX)->SetWindowText(_T(""));	
		}
		else
		{
			GetDlgItem(IDC_EDITSEARCHMIN)->SetWindowText(_T(""));
		}
	}
	//OnEnChangeSearchname(); // EC 08.07.03
	EMULE_CATCH
}

void CSearchDlg::OnBnClickedStarts()
{
	EMULE_TRY
	if (!GetDlgItem(IDC_STARTS)->IsWindowEnabled()) return; // EC 10.07.03
	searchprogress.SetPos(0);

	if (GetDlgItem(IDC_ELINK)->GetWindowTextLength())
	{
		CString strlink;
		GetDlgItem(IDC_ELINK)->GetWindowText(strlink);
		if (strlink.Right(1)!=_T("/")) strlink+=_T("/");
		GetDlgItem(IDC_ELINK)->SetWindowText(_T(""));
		try 
		{
			CED2KLink* pLink = CED2KLink::CreateLinkFromUrl(strlink);
			_ASSERT( pLink !=0 );
			if ( pLink->GetKind() == CED2KLink::kFile)
			{
				theApp.downloadqueue->AddFileLinkToDownload(pLink->GetFileLink());
			} else {
				delete pLink; // [i_a] memleak
				throw CString(_T("bad link"));
			}
			delete pLink;
		} catch(CString &error) {
			OUTPUT_DEBUG_TRACE();
			CString buffer;
			buffer.Format(GetResString(IDS_ERR_INVALIDLINK),error.GetBuffer());
			AddLogLine(true, IDS_ERR_LINKERROR, buffer);
		}
		return;
	}
	if (GetDlgItem(IDC_SEARCHNAME)->GetWindowTextLength())
	{
		switch (methodbox.GetCurSel())
		{
		case 0:
		case 1:
			StartNewSearch();
			break;

		case 2:
		case 3:
			ShellOpenFile(CreateWebQuery());
			return;
		default:
			return;
		}
	}
	EMULE_CATCH
}

void CSearchDlg::OnTimer(UINT nIDEvent)
{
	EMULE_TRY
	CResizableDialog::OnTimer(nIDEvent);
#ifdef OLD_SOCKETS_ENABLED
	if (theApp.serverconnect->IsConnected())
	{
		CServer* toask = theApp.serverlist->GetNextSearchServer();
		if (toask == theApp.serverlist->GetServerByAddress(theApp.serverconnect->GetCurrentServer()->GetAddress(),theApp.serverconnect->GetCurrentServer()->GetPort()))
			toask = theApp.serverlist->GetNextSearchServer();

		if (toask && theApp.serverlist->GetServerCount()-1 != servercount)
		{
			servercount++;
			theApp.serverconnect->SendUDPPacket(searchpacket,toask,false);
			searchprogress.StepIt();
		}
		else
			OnBnClickedCancels();
	}
	else
#endif //OLD_SOCKETS_ENABLED
		OnBnClickedCancels();
	EMULE_CATCH
}

void CSearchDlg::OnBnClickedCancels()
{
	EMULE_TRY
	canceld = true;
	globsearch = false;
	if (global_search_timer)
	{
		delete searchpacket;
		searchpacket	=	NULL;
		KillTimer(global_search_timer);
		global_search_timer = 0;
		searchprogress.SetPos(0);
	}
	GetDlgItem(IDC_CANCELS)->EnableWindow(false);
	GetDlgItem(IDC_STARTS)->EnableWindow(true);
	GetDlgItem(IDC_CLEARALL)->EnableWindow(true);
	EMULE_CATCH
}


void CSearchDlg::LocalSearchEnd(uint16 count)
{
	EMULE_TRY
	if (!canceld && count > MAX_RESULTS)
		OnBnClickedCancels();
	if (!canceld){	
		if (!globsearch)
		{
			GetDlgItem(IDC_STARTS)->EnableWindow(true);
			GetDlgItem(IDC_CANCELS)->EnableWindow(false);
			GetDlgItem(IDC_CLEARALL)->EnableWindow(true);
		}
		else
			global_search_timer = SetTimer(1, 750, 0);
	}
	EMULE_CATCH
}
void CSearchDlg::AddUDPResult(uint16 count)
{
	if (!canceld && count > MAX_RESULTS)
		OnBnClickedCancels();
}

void CSearchDlg::OnBnClickedSdownload()
{
	DownloadSelected();
}

BOOL CSearchDlg::PreTranslateMessage(MSG* pMsg) 
{
	EMULE_TRY
	if((pMsg->message == WM_KEYDOWN) && (pMsg->wParam == 13))
	{
		if (pMsg->hwnd == GetDlgItem(IDC_SEARCHLIST)->m_hWnd)
			OnBnClickedSdownload();
		else if (pMsg->hwnd == GetDlgItem(IDC_ELINK)->m_hWnd)
			OnBnClickedStarts();
		else if (pMsg->hwnd == GetDlgItem(IDC_SEARCHNAME)->m_hWnd ||
			pMsg->hwnd == GetDlgItem(IDC_TypeSearch)->m_hWnd ||
			pMsg->hwnd == GetDlgItem(IDC_EDITSEARCHMIN)->m_hWnd ||
			pMsg->hwnd == GetDlgItem(IDC_EDITSEARCHMAX)->m_hWnd ||
			pMsg->hwnd == GetDlgItem(IDC_EDITSEARCHAVAIBILITY)->m_hWnd ||
			pMsg->hwnd == GetDlgItem(IDC_SEARCHNAME_NOT)->m_hWnd ||
			pMsg->hwnd == GetDlgItem(IDC_METHOD)->m_hWnd)
			OnBnClickedStarts();
	}
	return CResizableDialog::PreTranslateMessage(pMsg);
	EMULE_CATCH
	return false;
}

void CSearchDlg::OnNMDblclkSearchlist(NMHDR *pNMHDR, LRESULT *pResult)
{
	EMULE_TRY
	OnBnClickedSdownload();
	*pResult = 0;
	EMULE_CATCH
}

CString	CSearchDlg::CreateWebQuery()
{
	EMULE_TRY
	CString query,tosearch;
	unsigned long num;
	switch (methodbox.GetCurSel())
	{
	case 2:
		query = _T("http://www.filedonkey.com/fdsearch/index.php?");
		GetDlgItem(IDC_SEARCHNAME)->GetWindowText(tosearch);
		query += _T("pattern=")+ToQueryString(tosearch);
		GetDlgItem(IDC_TypeSearch)->GetWindowText(tosearch);
		if (GetResString(IDS_SEARCH_AUDIO)==tosearch)
			tosearch=_T("Audio");
		else if (GetResString(IDS_SEARCH_VIDEO)==tosearch)
			tosearch=_T("Video");
		else if (GetResString(IDS_SEARCH_PRG)==tosearch)
			tosearch=_T("Pro");
		else if (GetResString(IDS_SEARCH_DOC)==tosearch)	// netwolf 06.05.03
			tosearch=_T("Doc");		
		else
			tosearch=_T("All");
		query +=_T("&media=") + tosearch; //Cax2 added filedonkey 'type' option
		query += _T("&action=search&name=FD-Search&op=modload&file=index&requestby=emule");
		break;
	case 3:
		query = _T("http://www.jigle.com/search?");
		GetDlgItem(IDC_SEARCHNAME)->GetWindowText(tosearch);
		query += _T("p=")+ToQueryString(tosearch) + _T("&ma=");
		GetDlgItem(IDC_EDITSEARCHAVAIBILITY)->GetWindowText(tosearch);
		if (_tstol(tosearch)>1000) tosearch=_T("1000");
		else if (_tstoi(tosearch)>500) tosearch=_T("500");
		else if (_tstoi(tosearch)>200) tosearch=_T("200");
		else if (_tstoi(tosearch)>100) tosearch=_T("100");
		else if (_tstoi(tosearch)>50) tosearch=_T("50");
		else if (_tstoi(tosearch)>20) tosearch=_T("20");
		else if (_tstoi(tosearch)>10) tosearch=_T("10");
		else tosearch=_T("1");
		query += tosearch +_T("&v=0&d=1&a=0&l=10");		//Cax2 might want to change to l=25 for more results per page... 
		GetDlgItem(IDC_TypeSearch)->GetWindowText(tosearch);
		if (GetResString(IDS_SEARCH_AUDIO)==tosearch)
			tosearch=_T("1");
		else if (GetResString(IDS_SEARCH_VIDEO)==tosearch)
			tosearch=_T("2");
		else if (GetResString(IDS_SEARCH_PICS)==tosearch)
			tosearch=_T("3");
		else if (GetResString(IDS_SEARCH_PRG)==tosearch)
			tosearch=_T("4");
		else if (GetResString(IDS_SEARCH_DOC)==tosearch)	// netwolf 06.05.03	// 5 is jigles search for docs string
			tosearch=_T("5");
		else
			tosearch=_T("0");
		query +=_T("&t=") +tosearch;
		GetDlgItem(IDC_EDITSEARCHMIN)->GetWindowText(tosearch);
		num=_tstol(tosearch);
		tosearch.Format(_T("%u"),((num>0)?num *1048576:1));
		query +=_T("&sl=") +tosearch;
		GetDlgItem(IDC_EDITSEARCHMAX)->GetWindowText(tosearch);
		num=_tstol(tosearch);
		tosearch.Format(((num>0)?_T("%u"):_T("")),num * 1048576);
		query +=_T("&su=") + tosearch;
		break;
	default:
		return CString(_T(""));
	}
	return query;
	EMULE_CATCH
	return CString(_T(""));
}

CString	CSearchDlg::ToQueryString(CString str){
	EMULE_TRY
	CString sTmp = URLEncode(str);
	sTmp.Replace(_T("%20"),_T("+"));
	return sTmp;
	EMULE_CATCH
	return CString(_T(""));
}

void CSearchDlg::DownloadSelected()
{
	EMULE_TRY
	int index = -1; 
	POSITION pos = searchlistctrl.GetFirstSelectedItemPosition(); 
	while(pos != NULL) 
	{ 
		index = searchlistctrl.GetNextSelectedItem(pos); 
		if(index > -1)
		{
			theApp.downloadqueue->AddSearchToDownload((CSearchFile*)searchlistctrl.GetItemData(index),m_cattabs.GetCurSel());
			// Lord KiRon
			//searchlistctrl.Update(index);
			searchlistctrl.RedrawItems(index,index);
		}
	} 
	EMULE_CATCH
}


void CSearchDlg::Localize()
{
	EMULE_TRY
	searchlistctrl.Localize();

	m_ctrlSearchFrm.SetText(GetResString(IDS_SW_SEARCHBOX));
	GetDlgItem(IDC_SNAME_LBL)->SetWindowText(GetResString(IDS_SW_NAME));
	GetDlgItem(IDC_SNAME_LBL2)->SetWindowText(GetResString(IDS_SCH_EXCEPT).MakeLower());
	GetDlgItem(IDC_STYPE_LBL)->SetWindowText(GetResString(IDS_SW_TYPE));
	GetDlgItem(IDC_SMETHOD_LBL)->SetWindowText(GetResString(IDS_SW_METHOD));
	m_ctrlDirectDlFrm.SetText(GetResString(IDS_SW_DIRECTDOWNLOAD));
	GetDlgItem(IDC_ED2KLINK_LBL)->SetWindowText(GetResString(IDS_SW_LINK));

	GetDlgItem(IDC_STARTS)->SetWindowText(GetResString(IDS_SW_START));
	GetDlgItem(IDC_CANCELS)->SetWindowText(GetResString(IDS_SW_CANCEL));
	GetDlgItem(IDC_CLEARALL)->SetWindowText(GetResString(IDS_REMOVEALLSEARCH));

	GetDlgItem(IDC_RESULTS_LBL)->SetWindowText(GetResString(IDS_SW_RESULT));
	GetDlgItem(IDC_SDOWNLOAD)->SetWindowText(GetResString(IDS_SW_DOWNLOAD));

	GetDlgItem(IDC_SEARCHMINSIZE)->SetWindowText(GetResString(IDS_SEARCHMINSIZE) + _T(" (") + GetResString(IDS_MBYTES) + _T(")"));
	GetDlgItem(IDC_SEARCHMAXSIZE)->SetWindowText(GetResString(IDS_SEARCHMAXSIZE) + _T(" (") + GetResString(IDS_MBYTES) + _T(")"));
	GetDlgItem(IDC_SEARCHAVAIL)->SetWindowText(GetResString(IDS_SEARCHAVAIL));
	GetDlgItem(IDC_SEARCH_RESET)->SetWindowText(GetResString(IDS_PW_RESET)); // EC
	GetDlgItem(IDC_DOWNLOAD_ALL_ED2K)->SetWindowText(GetResString(IDS_DOWNLOAD_ALL_ED2K)); //<<--enkeyDEV

	methodbox.ResetContent();
	methodbox.SetImageList(&m_BoxImageList);
	COMBOBOXEXITEM     cbi;
	cbi.mask = CBEIF_IMAGE | CBEIF_OVERLAY | CBEIF_SELECTEDIMAGE | CBEIF_TEXT;
	CString            str[4];
	str[0]=GetResString(IDS_PW_SERVER);
	str[1]=GetResString(IDS_SW_GLOBAL);
	str[2]="FileDonkey";
	str[3]="Jigle";
	for (int i=0; i<4;i++)
	{
		cbi.iItem = i;
		cbi.pszText = (LPTSTR)(LPCTSTR)str[i];
		cbi.cchTextMax = str[i].GetLength();
		cbi.iImage = i;
		cbi.iSelectedImage = i;
		cbi.iOverlay = i;
		methodbox.InsertItem(&cbi);
	}
	methodbox.SetCurSel(theApp.glob_prefs->GetMethod());

	Stypebox.ResetContent();
	Stypebox.AddString(GetResString(IDS_SEARCH_ANY));
	Stypebox.AddString(GetResString(IDS_SEARCH_ARC)+_T(" (.zip .rar .ace...)"));
	Stypebox.AddString(GetResString(IDS_SEARCH_AUDIO)+_T(" (.mp3 .ogg .wav...)"));
	Stypebox.AddString(GetResString(IDS_SEARCH_CDIMG)+_T(" (.iso .bin .nrg...)"));
	Stypebox.AddString(GetResString(IDS_SEARCH_PICS)+_T(" (.jpg .gif .png...)"));
	Stypebox.AddString(GetResString(IDS_SEARCH_PRG)+_T(" (.exe .zip .rar...)"));
	Stypebox.AddString(GetResString(IDS_SEARCH_VIDEO)+_T(" (.avi .mpg .ogm...)"));
	Stypebox.AddString(GetResString(IDS_SEARCH_DOC)+_T(" (.doc .txt .pdf...)"));
	//Stypebox.AddString(GetResString(IDS_SEARCH_USER));
	Stypebox.SetCurSel(0);
	EMULE_CATCH
}

void CSearchDlg::OnBnClickedClearall()
{
	OnBnClickedCancels();
	DeleteAllSearchs();
}

void CSearchDlg::DoNewSearch(CString searchString, CString typeText,unsigned long min, unsigned long max, 
		int avaibility,CString extension, bool doGlobal){
	EMULE_TRY

#ifdef OLD_SOCKETS_ENABLED
	if (!theApp.serverconnect->IsConnected()) return;
#endif //OLD_SOCKETS_ENABLED

		m_nSearchID++;
		theApp.searchlist->NewSearch(&searchlistctrl,typeText,m_nSearchID);
		canceld = false;

		long typeNemonic=      0x00030001;
		long extensionNemonic= 0x00040001;
		long avaibilityNemonic=0x15000101;
		long minNemonic=       0x02000101;
		long maxNemonic=	   0x02000102;
		byte stringParameter=1;
		byte typeParameter=2;
		byte numericParameter=3;
		int andParameter=0x0000;
		//int orParameter=0x0100;

		CString type=_T("");
		if (GetResString(IDS_SEARCH_AUDIO)==typeText) type.Format(_T("Audio")); 
		if (GetResString(IDS_SEARCH_VIDEO)==typeText) type.Format(_T("Video")); 
		if (GetResString(IDS_SEARCH_PRG)==typeText) type.Format(_T("Pro")); 
		if (GetResString(IDS_SEARCH_PICS)==typeText) type.Format(_T("Image")); 
		if (GetResString(IDS_SEARCH_DOC)==typeText) type.Format(_T("Doc"));
		if (GetResString(IDS_SEARCH_CDIMG)==typeText) type.Format(_T("Pro")); 
		if (GetResString(IDS_SEARCH_ARC)==typeText) type.Format(_T("Pro")); 

		CMemFile data(100); 
		uint16 nSize;
		TCHAR* formatC;

		if (extension.GetLength()>0 && extension.GetAt(0)!='.' ) extension=_T(".")+extension;

		if ( searchString.GetLength()==0 && extension.GetLength()==0) 
		{
			return;
		}

		int parametercount=0; //must be written parametercount-1 parmeter headers

		if ( searchString.GetLength()>0)
		{
		  parametercount++;
		  if (parametercount>1)
		      data.Write(&andParameter,2);
		}

		if (type.GetLength()>0)
		{
		  parametercount++;
		  if (parametercount>1)
		      data.Write(&andParameter,2);
		}
	  
		if (min>0)
		{
		  parametercount++;
		  if (parametercount>1)
			  data.Write(&andParameter,2);
		}
        
		if (max>0)
		{
		  parametercount++;
		  if (parametercount>1)
			  data.Write(&andParameter,2);
		}
        
		if (avaibility>0)
		{
		  parametercount++;
		  if (parametercount>1)
			  data.Write(&andParameter,2);
		}
        
		if (extension.GetLength()>0)
		{
		  parametercount++;
		  if (parametercount>1)
		      data.Write(&andParameter,2);
		}

        //body
		if (searchString.GetLength()>0) //search a string
		{
			data.Write(&stringParameter,1); //write the parameter type
			nSize = searchString.GetLength(); 
			data.Write(&nSize,2);  // write parameter length
			data.Write(searchString.GetBuffer() ,nSize); //write the searched string 
		}

		if (type.GetLength()>0)
		{
			data.Write(&typeParameter,1); //write the parameter type
			nSize=type.GetLength(); 
			data.Write(&nSize,2);   //write the length
			formatC=type.GetBuffer(); 
			data.Write(formatC,nSize); //write parameter
			data.Write(&typeNemonic,3); //nemonic for this kind of parameter (only 3 bytes!!)
		}

		if (min>0)
		{
			data.Write(&numericParameter,1); //write the parameter type
			data.Write(&min,4);		   //write the parameter
			data.Write(&minNemonic,4);    //nemonic for this kind of parameter
		}

		if (max>0)
		{
			data.Write(&numericParameter,1); //write the parameter type
			data.Write(&max,4);		   //write the parameter
			data.Write(&maxNemonic,4);    //nemonic for this kind of parameter
		}

		if (avaibility>0)
		{
			data.Write(&numericParameter,1); //write the parameter type
			data.Write(&avaibility,4);    //write the parameter
			data.Write(&avaibilityNemonic,4);  //nemonic for this kind of parameter
		}

		if (extension.GetLength()>0)
		{
			data.Write(&stringParameter,1); //write the parameter type
			nSize=extension.GetLength(); 
			data.Write(&nSize,2);   //write the length
			formatC=extension.GetBuffer(); 
			data.Write(formatC,nSize); //write parameter
			data.Write(&extensionNemonic,3); //nemonic for this kind of parameter (only 3 bytes!!)
		}


		Packet* packet = new Packet(&data);
		packet->opcode = OP_SEARCHREQUEST;
		
		theApp.uploadqueue->AddUpDataOverheadServer(packet->size);
#ifdef OLD_SOCKETS_ENABLED
		theApp.serverconnect->SendPacket(packet,false);
#endif //OLD_SOCKETS_ENABLED

		if (doGlobal){
			if( theApp.glob_prefs->Score() ){
				theApp.serverlist->ResetSearchServerPos();
			}

			if (globsearch) delete searchpacket;
			searchpacket = packet;
			searchpacket->opcode = OP_GLOBSEARCHREQ;
			servercount = 0;
			searchprogress.SetRange32(0,theApp.serverlist->GetServerCount()-1);
			globsearch = true;
		}
		else{
			globsearch = false;
			delete packet;
		}
		SearchData sd;
		sd.sNotSearch = "";
		sd.bDocumentSearch = (GetResString(IDS_SEARCH_DOC)==typeText);
		m_SearchMap.SetAt(m_nSearchID, sd);
		CreateNewTab(searchString,m_nSearchID);
	EMULE_CATCH
}

void CSearchDlg::StartNewSearch()
{
	EMULE_TRY
	bool isThisGlobal=(methodbox.GetCurSel()==1);
#ifdef OLD_SOCKETS_ENABLED
	if (!theApp.serverconnect->IsConnected())
		MessageBox(GetResString(IDS_ERR_NOTCONNECTED),GetResString(IDS_NOTCONNECTED),64);
	else
#endif //OLD_SOCKETS_ENABLED
	{
		m_nSearchID++;
		CString typeText;
		CString searchString;
		GetDlgItem(IDC_TypeSearch)->GetWindowText(typeText);
		int idx=typeText.Find(_T(" (."));	//Cax2 bugfix: remove all examples from typeText
		if (idx>0)
			typeText.Delete(idx,typeText.GetLength()-idx);
		GetDlgItem(IDC_SEARCHNAME)->GetWindowText(searchString);
		theApp.searchlist->NewSearch(&searchlistctrl,typeText,m_nSearchID);
		GetDlgItem(IDC_STARTS)->EnableWindow(false);
		GetDlgItem(IDC_CANCELS)->EnableWindow(true);
		
		canceld = false;

		long typeNemonic=  0x00030001;
		long extensionNemonic= 0x00040001;
		long avaibilityNemonic=0x15000101;
		long minNemonic=       0x02000101;
		long maxNemonic=	   0x02000102;
		byte stringParameter=1;
		byte typeParameter=2;
		byte numericParameter=3;
		int andParameter=0x0000;
		int orParameter=0x0100;

		CMemFile* data = new CMemFile(100); 
		uint16 nSize;
		TCHAR* formatC;
		unsigned long avaibility;

		CString sizeMin,sizeMax,extension,avaibilitystr,type;
		GetDlgItem(IDC_EDITSEARCHMIN)->GetWindowText(sizeMin);
		GetDlgItem(IDC_EDITSEARCHMAX)->GetWindowText(sizeMax);
		unsigned long max=_tstol(sizeMax.GetString())*1048576; 
		unsigned long min=_tstol(sizeMin.GetString())*1048576; 
		if (max<min) max=0;//max file size // netwolf: if no max size is specified or max<min, dont send max.size limit (at lugdunums request)
		type="";
		if (GetResString(IDS_SEARCH_AUDIO)==typeText) type="Audio"; 
		if (GetResString(IDS_SEARCH_VIDEO)==typeText) type="Video";
		//archives and programs treated the same by servers
		if (GetResString(IDS_SEARCH_ARC)==typeText||GetResString(IDS_SEARCH_PRG)==typeText) type="Pro"; 
		if (GetResString(IDS_SEARCH_PICS)==typeText) type="Image"; 
		if (GetResString(IDS_SEARCH_DOC)==typeText) type="";

		GetDlgItem(IDC_EDITSEARCHAVAIBILITY)->GetWindowText(avaibilitystr); 
		avaibility=_tstol(avaibilitystr.GetString());

		if ( searchString.GetLength()==0 && extension.GetLength()==0) 
		{
			delete data;
			return;
		}

		int parametercount=0; //must be written parametercount-1 parmeter headers

		//Cax2 - get users: no other parameters allowed
		//Get users TODO - still need to display the results sent by the server!!!
		if(GetResString(IDS_SEARCH_USER)!=typeText)
		{
			if ( searchString.GetLength()>0)
			{
			parametercount++;
			if (parametercount>1)
				data->Write(&andParameter,2);
			}

		if (type.GetLength()>0)
			{
			parametercount++;
			if (parametercount>1)
				data->Write(&andParameter,2);
			}
		  
			if (min>0)
			{
			parametercount++;
			if (parametercount>1)
				data->Write(&andParameter,2);
			}
	        
			if (max>0)
			{
			parametercount++;
			if (parametercount>1)
				data->Write(&andParameter,2);
			}
	        
			if (avaibility>0)
			{
			parametercount++;
			if (parametercount>1)
				data->Write(&andParameter,2);
			}
	        
			if (extension.GetLength()>0)
			{
			parametercount++;
			if (parametercount>1)
				data->Write(&andParameter,2);
			}
		}

		//body
		if (!searchString.IsEmpty()) //search a string
		{
			data->Write(&stringParameter,1); //write the parameter type
			nSize = searchString.GetLength(); 
			data->Write(&nSize,2);  // write parameter length
			formatC=searchString.GetBuffer(); 
			data->Write(formatC,nSize); //write the searched string 
		}
		//Cax2 - get users: no other parameters allowed
		if(GetResString(IDS_SEARCH_USER)!=typeText)
		{
			if (!type.IsEmpty())
			{
				data->Write(&typeParameter,1); //write the parameter type
				nSize=type.GetLength(); 
				data->Write(&nSize,2);   //write the length
				formatC=type.GetBuffer(); 
				data->Write(formatC,nSize); //write parameter
				data->Write(&typeNemonic,3); //mnemonic for this kind of parameter (only 3 bytes!!)
			}

			if (min>0)
			{
				data->Write(&numericParameter,1); //write the parameter type
				data->Write(&min,4);		   //write the parameter
				data->Write(&minNemonic,4);    //nemonic for this kind of parameter
			}

			if (max>0)
			{
				data->Write(&numericParameter,1); //write the parameter type
				data->Write(&max,4);		   //write the parameter
				data->Write(&maxNemonic,4);    //nemonic for this kind of parameter
			}

			if (avaibility>0)
			{
				data->Write(&numericParameter,1); //write the parameter type
				data->Write(&avaibility,4);    //write the parameter
				data->Write(&avaibilityNemonic,4);  //nemonic for this kind of parameter
			}

			if (extension.GetLength()>0)
			{
				data->Write(&stringParameter,1); //write the parameter type
				nSize=extension.GetLength(); 
				data->Write(&nSize,2);   //write the length
				formatC=extension.GetBuffer(); 
				data->Write(formatC,nSize); //write parameter
				data->Write(&extensionNemonic,3); //nemonic for this kind of parameter (only 3 bytes!!)
			}
		}

		Packet* packet = new Packet(data);
		if ( packet )
		{
			//Cax2 - get users
			packet->opcode =(GetResString(IDS_SEARCH_USER)==typeText)?OP_SEARCH_USER:OP_SEARCHREQUEST;
			delete data;
			theApp.uploadqueue->AddUpDataOverheadServer(packet->size);
#ifdef OLD_SOCKETS_ENABLED
			theApp.serverconnect->SendPacket(packet,false);
#endif //OLD_SOCKETS_ENABLED

			if (isThisGlobal){
				if( theApp.glob_prefs->Score() ){
					theApp.serverlist->ResetSearchServerPos();
				}
				if ( searchpacket )
				{
					delete searchpacket;
				}
				searchpacket = packet;
				searchpacket->opcode = OP_GLOBSEARCHREQ;
				servercount = 0;
				searchprogress.SetRange32(0,theApp.serverlist->GetServerCount()-1);
				globsearch = true;
			}
			else{
				globsearch = false;
				delete packet;
			}
			CString searchNotString;
			GetDlgItem(IDC_SEARCHNAME_NOT)->GetWindowText(searchNotString);
			searchNotString.MakeLower();
			SearchData sd;
			sd.sNotSearch = searchNotString;
			sd.bDocumentSearch = (GetResString(IDS_SEARCH_DOC)==typeText);
			m_SearchMap.SetAt(m_nSearchID, sd);
			CreateNewTab(searchString,m_nSearchID);
		}
	}
	EMULE_CATCH
}

void CSearchDlg::CreateNewTab(CString searchString,uint32 nSearchID)
{
	EMULE_TRY
	// add new tab
	TCITEM newitem;
	if (searchString.GetLength() == 0)
		searchString = "-";
	newitem.mask = TCIF_PARAM|TCIF_TEXT|TCIF_IMAGE;
	newitem.lParam = (LPARAM)nSearchID;
	newitem.pszText = searchString.GetBuffer();
	newitem.cchTextMax = (int)searchString.GetLength()+10;
	newitem.iImage = 0;
	uint16 itemnr = searchselect.InsertItem(searchselect.GetItemCount(),&newitem);
	if (!searchselect.IsWindowVisible())
		searchselect.ShowWindow(SW_SHOW);
	searchselect.SetCurSel(itemnr);
	searchlistctrl.ShowResults(nSearchID);
	EMULE_CATCH
}

void CSearchDlg::DeleteSearch(uint32 nSearchID)
{
	EMULE_TRY
	TCITEM item;
	item.mask = TCIF_PARAM;
	for( int i = 0, nItems = searchselect.GetItemCount(); nItems != i; ++i )
	{
		searchselect.GetItem(i,&item);
		if (item.lParam == nSearchID)
			break;
	}
	if (item.lParam != nSearchID)
		return;
	if ((!canceld) && (nSearchID == m_nSearchID))
		OnBnClickedCancels();  //Sony - cancel active search before closing active tab
	theApp.searchlist->RemoveResults(nSearchID);
	searchselect.DeleteItem(i);
	if ( --nItems )
	{
		if( i >= nItems ) i = nItems - 1;
		searchselect.SetCurSel(i);
		item.mask = TCIF_PARAM;
		searchselect.GetItem(i,&item);
		searchlistctrl.ShowResults(item.lParam);
	}
	else
	{
		searchlistctrl.DeleteAllItems();
		searchselect.ShowWindow(SW_HIDE);
		searchlistctrl.NoTabs();
	}
	EMULE_CATCH
}

void CSearchDlg::DeleteAllSearchs()
{
	EMULE_TRY
	theApp.searchlist->Clear();
	searchlistctrl.DeleteAllItems();
	searchselect.ShowWindow(SW_HIDE);
	searchselect.DeleteAllItems();
	EMULE_CATCH
}

void CSearchDlg::OnTcnSelchangeTab1(NMHDR *pNMHDR, LRESULT *pResult)
{
	EMULE_TRY
	const int cur_sel = searchselect.GetCurSel();
	if( -1 == cur_sel ) return;

	TCITEM item;
	item.mask = TCIF_PARAM;
	searchselect.GetItem( cur_sel,&item );
	searchlistctrl.ShowResults( item.lParam );
	*pResult = 0;
	EMULE_CATCH
}

LRESULT CSearchDlg::OnCloseTab(WPARAM wparam, LPARAM lparam) {
	EMULE_TRY
	TCITEM item;
	item.mask = TCIF_PARAM;
	int i = (int)wparam;
	searchselect.GetItem(i,&item);
	int nSearchID = item.lParam;

	if ((!canceld) && (nSearchID == m_nSearchID))
		OnBnClickedCancels();  //Sony - cancel active search before closing active tab
	DeleteSearch(nSearchID);

	return true;
	EMULE_CATCH
	return false;
}
// EC 08.07.03
/*
void CSearchDlg::OnEnChangeSearchname()
{
	EMULE_TRY
	GetDlgItem(IDC_STARTS)->EnableWindow(true); 
	GetDlgItem(IDC_CANCELS)->EnableWindow(false);	
	GetDlgItem(IDC_CLEARALL)->EnableWindow(true); 
	EMULE_CATCH
}
*/
// EC Ends
void CSearchDlg::OnBnClickedSearchReset()
{
	EMULE_TRY
	GetDlgItem(IDC_EDITSEARCHAVAIBILITY)->SetWindowText(_T(""));	
	GetDlgItem(IDC_EDITSEARCHMIN)->SetWindowText(_T(""));	
	GetDlgItem(IDC_EDITSEARCHMAX)->SetWindowText(_T(""));	
	GetDlgItem(IDC_SEARCHNAME)->SetWindowText(_T(""));
	GetDlgItem(IDC_SEARCHNAME_NOT)->SetWindowText(_T(""));
	Stypebox.SetCurSel(Stypebox.FindString(-1,GetResString(IDS_SEARCH_ANY)));

	//OnEnChangeSearchname(); // EC 08.07.03
	EMULE_CATCH
}

void CSearchDlg::OnStnClickedSearchextensionLbl()
{
	// TODO: Add your control notification handler code here
}

void CSearchDlg::OnEnChangeMethod()
{
	EMULE_TRY
	theApp.glob_prefs->SetMethod(methodbox.GetCurSel());
	EMULE_CATCH
}

// START - enkeyDEV(Ottavio84) -Download all ed2ks in clipboard-
bool isprefix(const TCHAR* prefix, const TCHAR* string)
{
	EMULE_TRY
	while (_tcsnextc(prefix)) {
		if (_tcsnextc(prefix) != _tcsnextc(string))
			return false;
		prefix = _tcsinc(prefix);
		string = _tcsinc(string);
	}
	return true;
	EMULE_CATCH
	return false;
}

void CSearchDlg::AddEd2kLinksToDownload(CString strlink,uint8 cat){
	EMULE_TRY

	CString resToken;
	int curPos=0;

	resToken= strlink.Tokenize(_T("\t\n\r"),curPos);
	while (resToken != "")
	{
		
		if (resToken.Right(1)!="/") resToken+="/";
		try {
			CED2KLink* pLink = CED2KLink::CreateLinkFromUrl(resToken.Trim());
			_ASSERT( pLink !=0 );
			if ( pLink->GetKind() == CED2KLink::kFile) {
				theApp.downloadqueue->AddFileLinkToDownload(pLink->GetFileLink(),cat);
			} else {
				delete pLink; // [i_a] memleak
				throw CString("bad link");
			}
			delete pLink;
		} catch(CString error){
			OUTPUT_DEBUG_TRACE();
			CString buffer;
			buffer.Format(GetResString(IDS_ERR_INVALIDLINK),error.GetBuffer());
			theApp.emuledlg->AddLogLine(true, IDS_ERR_LINKERROR, buffer);
		}
		resToken= strlink.Tokenize(_T("\t\n\r"),curPos);
	}

	EMULE_CATCH
}

void CSearchDlg::OnBnClickedDownloadAllEd2k()
{
	EMULE_TRY
	CString clipboard = theApp.CopyTextFromClipboard();
	const TCHAR* text = clipboard;
	CString newlink;
	CString msglinks;
	CTypedPtrList<CPtrList, CED2KLink*> links;
	while (_tcsnextc(text)) {
		if (isprefix(_T("ed2k://"), text)) {
			bool bLinkEnded = false;
			TCHAR prevchar = 0;
			while (_tcsnextc(text))
			{
				if (_tcsnextc(text) == '\n') {
					text = _tcsinc(text);
					continue;
				} else if (_tcsnextc(text) == '\r') {
					text = _tcsinc(text);
					continue;
				} else if (isprefix(_T("> "), text)) {
					text += _tcslen(_T("> "));
					continue;
				} else if (_tcsnextc(text) == '>') {
					text = _tcsinc(text);
					continue;
				}
				newlink.AppendChar(_tcsnextc(text));

				TCHAR nextchar = _tcsnextc(_tcsinc(text));

				// Link ends with "|/"
				if ((_tcsnextc(text) == '/') && ((nextchar != _T('|')) && (nextchar != _T('/'))))
					bLinkEnded = true;

				// Link ends with "|"
				if ((_tcsnextc(text) == '|') && (prevchar != '/') &&
					(_tcschr(_T(" \""), nextchar) || _tcschr(_T("\r\n"), nextchar)))
				{
					newlink.AppendChar(_T('/'));
					bLinkEnded = true;
				}

				if (bLinkEnded) {
					try {
						CED2KLink* pLink = CED2KLink::CreateLinkFromUrl(newlink);
						_ASSERT( pLink !=0 );
						if ( pLink->GetKind() == CED2KLink::kFile) {
							msglinks += newlink + _T("\n");
							links.AddTail(pLink);
						} else {
							delete pLink;
						}
					}
					catch(...) {}

					newlink = "";
					break;
				}
				prevchar = _tcsnextc(text);
				text = _tcsinc(text);
			}
		}
		text = _tcsinc(text);
	}
	if (links.IsEmpty()) {
		MessageBox(GetResString(IDS_ED2KNOLINKFROMCLIPBOARD)); //"No ED2K links found in clipboard"
	} else {
		CString msg;
		msg.Format(GetResString(IDS_ED2KCONFIRMFROMCLIPBOARD), msglinks); // "Add to downloads these links?\n%s", msglinks
		int retvalue = MessageBox(msg, NULL, MB_YESNO);
		if (retvalue == IDYES) {
			while (!links.IsEmpty()) {
				theApp.downloadqueue->AddFileLinkToDownload(links.GetHead()->GetFileLink());
				delete links.RemoveHead();
			}
		} else 
			while (!links.IsEmpty())
				delete links.RemoveHead();
	}
	EMULE_CATCH
}
// END - enkeyDEV(Ottavio84) -Download all ed2ks in clipboard-

void CSearchDlg::OnDestroy()
{
	EMULE_TRY
	CResizableDialog::OnDestroy();
	//Resources cleanup - [TwoBottle Mod]
	DestroyIcon(GetSearchLstStatic()->SetIcon(oldSearchLstIcon));
	m_BoxImageList.DeleteImageList();	// eklmn: bugfix(01): resource cleanup due to ImageLists recreation
	EMULE_CATCH
}

// Ultras - to set a focus in the search field
LRESULT CSearchDlg::OnShowWindow(WPARAM wparam, LPARAM lparam) {
	const LRESULT ret = DefWindowProc( WM_SHOWWINDOW, wparam, lparam );
	if( !ret && wparam && !lparam )
		GetDlgItem(IDC_SEARCHNAME)->SetFocus();

	return ret;
}

CString	CSearchDlg::GetNotSearch(int nSearchId)
{
	SearchData sd;
	if(m_SearchMap.Lookup(nSearchId, sd))
		return sd.sNotSearch;
	else
		return _T("");
}

bool CSearchDlg::IsDocumentSearch(int nSearchId)
{
	SearchData sd;
	if(m_SearchMap.Lookup(nSearchId, sd))
		return sd.bDocumentSearch;
	else
		return false;
}

void CSearchDlg::UpdateCatTabs()
{
	int oldsel=m_cattabs.GetCurSel();
	m_cattabs.DeleteAllItems();

	for (int ix=0;ix<theApp.glob_prefs->GetCatCount();ix++)
		m_cattabs.InsertItem(ix,(ix==0)?GetResString(IDS_ALL):theApp.glob_prefs->GetCategory(ix)->title);

	if (oldsel>=m_cattabs.GetItemCount() || oldsel==-1)
		oldsel=0;

	m_cattabs.SetCurSel(oldsel);
	int flag;
	flag=(m_cattabs.GetItemCount()>1) ? SW_SHOW:SW_HIDE;
	
	this->GetDlgItem(IDC_CATTAB2)->ShowWindow(flag);
	this->GetDlgItem(IDC_STATIC_DLTOof)->ShowWindow(flag);
}
