// EmClient.cpp
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

#ifdef NEW_SOCKETS

#include "OpCode.h"
#include "TaskProcessor_Main.h"
#include "EmEngine.h"
#include "../otherfunctions.h"
#include "../EngineData.h"

CEmClient::~CEmClient()
{
	if (closesocket(m_hSocket))
		AddDebugLogLine(false, "closesocket failed");
}

T_CLIENT_TYPE CEmClient_Peer::GetType() const
{
	return T_CLIENT_PEER;
}
T_CLIENT_TYPE CEmClient_Server::GetType() const
{
	return T_CLIENT_SERVER;
}
T_CLIENT_TYPE CEmClient_Web::GetType() const
{
	return T_CLIENT_WEB;
}

void CEmClient::OnConnected(CEmEngine&)
{
}
void CEmClient::OnAccepted(CEmEngine&)
{
}
void CEmClient::OnDisconnected(CEmEngine&)
{
}

void CEmClient_Peer::OnConnected(CEmEngine& stEngine)
{
	// send it a hello opcode
	COpCode_HELLO stMsg;
	stMsg._Client._Addr = 175;
	stMsg._Client._Port = stEngine.m_stData.GetPort();
	stMsg._UserName.m_strValue = stEngine.m_stData.GetUserNick();
	stMsg._UserName.m_bValid = TRUE;
	stMsg._ClientVersion.m_dwValue = 45;
	stMsg._ClientVersion.m_bValid = TRUE;
	stMsg._UserPort.m_dwValue = stEngine.m_stData.GetPort();
	stMsg._UserPort.m_bValid = TRUE;

	stEngine.m_stTcp.AllocSend(m_hSocket, stMsg);
}

void CEmClient_Server::OnConnected(CEmEngine& stEngine)
{
	// Disconnect from previous connected server, if any
	stEngine.DisconnectFromServer(stEngine.m_stData.GetConnectingServer());

	// Set connection info
	stEngine.m_stData.ConnectingTo(this);
	stEngine.m_stData.SetConnectionState(SERVER_WAITFORLOGIN);

	// Send LOGIN REQUEST
	COpCode_LOGINREQUEST stMsg;
	md4cpy(stMsg._Hash, stEngine.m_stData.GetUserHash());
	stMsg._ClientID = 0; // Must fill prev. client id
	stMsg._ClientPort = stEngine.m_stData.GetPort();
	stMsg._UserName.m_strValue = stEngine.m_stData.GetUserNick();
	stMsg._UserName.m_bValid = true;
	stMsg._ClientVersion.m_dwValue = EDONKEYVERSION;
	stMsg._ClientVersion.m_bValid = true;
	stMsg._UserPort.m_dwValue = stEngine.m_stData.GetPort();
	stMsg._UserPort.m_bValid = true;

	stEngine.m_stTcp.AllocSend(m_hSocket, stMsg);
}

void CEmClient_Server::OnDisconnected(CEmEngine& stEngine)
{
	// Set connection info
	if(stEngine.m_stData.GetConnectedServer() == m_hSocket)
		stEngine.m_stData.SetConnectionState(SERVER_DISCONNECTED);
}

void CEmClient_Web::OnConnected(CEmEngine& stEngine)
{
	// say something...
	char szSend[] = "GET / HTTP 1.1\r\n\r\n";
	stEngine.m_stTcp.AllocSend(m_hSocket, szSend, sizeof(szSend) - 1);
}

#endif