// Tabs2.cpp : implementation file
//

#include "stdafx.h"
#include "Tabs.h"
#include "UseDialogFont.h"
#include "otherfunctions.h"

// CTabs

//IMPLEMENT_DYNAMIC(CTabs, _TAB_BASECLASS)
CTabs::CTabs()
{
}

CTabs::~CTabs()
{
}


BEGIN_MESSAGE_MAP(CTabs, _TAB_BASECLASS)
	ON_WM_CREATE()
	ON_WM_ERASEBKGND()
	ON_WM_PAINT()
END_MESSAGE_MAP()



// CTabs message handlers

int CTabs::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (_TAB_BASECLASS::OnCreate(lpCreateStruct) == -1)
		return -1;

	ModifyStyle(0, TCS_OWNERDRAWFIXED);

	return 0;
}

void CTabs::DrawItem(LPDRAWITEMSTRUCT lpDIS)
{
	CDC dc;
	dc.Attach(lpDIS->hDC);
	DrawItem(&dc, lpDIS->itemID);
	dc.Detach();
}

void CTabs::DrawItem(CDC *pDC, int iItem)
{
	CRect rItem;
	GetItemRect(iItem, rItem);

	CRect rClient;
	GetClientRect(rClient);
	rItem.top = rClient.top;
	rItem.bottom = rClient.bottom+1;	// let it attache to the header
	
	CUseDialogFont Font(pDC);

	char szText[512] = "";
	TCITEM tcItem;
	tcItem.mask = TCIF_TEXT;
	tcItem.pszText = szText;
	tcItem.cchTextMax = sizeof(szText);
	GetItem(iItem, &tcItem);

	if(GetCurSel() == iItem)
	{
		pDC->FillSolidRect(rItem, GetSysColor(COLOR_BTNFACE));
		pDC->Draw3dRect(rItem, GetSysColor(COLOR_BTNHILIGHT), GetSysColor(COLOR_BTNSHADOW));
		pDC->SetTextColor(GetSysColor(COLOR_BTNTEXT));
		pDC->SetBkColor(GetSysColor(COLOR_BTNFACE));
	}
	else
	{
		CPen cpPen, *pOldPen;
		cpPen.CreatePen(PS_SOLID, 0, LightenColor(GetRGBColorTabs(), -40));
		pOldPen = pDC->SelectObject(&cpPen);
		
		if(GetCurSel() != iItem - 1)
		{
			pDC->MoveTo(rItem.left, rItem.top + 2);
			pDC->LineTo(rItem.left, rItem.bottom - 2);
		}
		if(GetCurSel() != iItem + 1)
		{
			pDC->MoveTo(rItem.right, rItem.top + 2);
			pDC->LineTo(rItem.right, rItem.bottom - 2);
		}
		
		pDC->SelectObject(pOldPen);

		pDC->SetTextColor(GetRGBColorGrayText());
		pDC->SetBkColor(GetRGBColorTabs());
	}

	CRect rText = rItem;
	rText.DeflateRect(2,2,2,2);
	pDC->DrawText(szText, rText, DT_CENTER|DT_VCENTER|DT_SINGLELINE|DT_END_ELLIPSIS);

	CWnd *pSB = GetWindow(GW_CHILD);
	if(pSB)
	{
		CRect rSB;
		pSB->GetWindowRect(rSB);
		ScreenToClient(&rSB);

		if (rSB.PtInRect(rItem.TopLeft()) || 
			rSB.PtInRect(rItem.BottomRight()) ||
			rSB.PtInRect(CPoint(rItem.right, rItem.top)) || 
			rSB.PtInRect(CPoint(rItem.left, rItem.bottom)) ||
			rItem.PtInRect(rSB.TopLeft()) ||
			rItem.PtInRect(rSB.BottomRight()) ||
			rItem.PtInRect(CPoint(rSB.right, rSB.top)) ||
			rItem.PtInRect(CPoint(rSB.left, rSB.bottom)))
		{
			pSB->Invalidate();
		}
	}
}

BOOL CTabs::OnEraseBkgnd(CDC* pDC)
{	
	return FALSE;
}

void CTabs::OnPaint()
{
	CPaintDC dc(this); // device context for painting

	CRect rClient;
	GetClientRect(rClient);
	dc.FillSolidRect(rClient, GetRGBColorTabs());

	int iItemCount = GetItemCount();
	for(int i = 0; i < iItemCount; i++)
	{
		DrawItem(&dc, i);
	}
}

COLORREF CTabs::GetRGBColorTabs()
{
	int r = GetRValue(GetRGBColorXP());
	int g = GetGValue(GetRGBColorXP());
	int b = GetBValue(GetRGBColorXP());

	int iMax = 255 - max(max(r,g),b);
	iMax = iMax - (int)(iMax*0.51);
	
	return RGB(r + iMax, g + iMax, b + iMax);
}

COLORREF CTabs::GetRGBColorXP()
{
	COLORREF cr = GetSysColor(COLOR_3DFACE);
	
	return RGB(((3 * GetRValue(cr) + 240) / 4) + 1,
			   ((3 * GetGValue(cr) + 240) / 4) + 1,
			   ((3 * GetBValue(cr) + 240) / 4) + 1);
}

COLORREF CTabs::GetRGBColorGrayText()
{
	int r = 0;
	int g = 0;
	int b = 0;

	r = r >> 1;
	g = g >> 1;
	b = b >> 1;

	int iMax = 255 - max(max(r,g),b);
	iMax = iMax - (int)(iMax * 0.60);
	
	return RGB(r + iMax, g + iMax, b + iMax);
}
